<?php
/*
 * This file is part of Web Pro Manager.
 * 
 * Web Pro Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Web Pro Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Web Pro Manager.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author The Web Pro Miami, Inc. <info@thewebpro.com>
 * @copyright The Web Pro Miami, Inc. <info@thewebpro.com>, http://www.thewebpro.com/
 * @license http://www.gnu.org/licenses/gpl.html GNU GPL
 * @package WebProManager
*/

if(file_exists("cms/inc_jpgutil.php") && is_file("cms/inc_jpgutil.php")){
	require("cms/inc_jpgutil.php");
}

// config
$nCompPath = "comp/";
$nUserCompPath = "comp/";

/* ------ MAIN Template Functions ------ */

$nOpenerTag="[#"; $nCloserTag="#]"; $nTagParamDelim="_";

function tmplShow($nTemplate){
	global $DBName,$Link;
	global $nTmplPath,$nReqTagsAdded,$nDefaultLang,$nSFLang;
	if(!$nTemplate){ return ""; }
	// Pull in template file
	switch($nTemplate){
		case "tmplHome": $nTmplPath = "home.html"; $nTmplPathLang = "home_$nSFLang.html"; break;
		case "tmplContent": $nTmplPath = "content.html"; $nTmplPathLang = "content_$nSFLang.html"; break;
		case "tmplSearch": $nTmplPath = "search.html"; $nTmplPathLang = "search_$nSFLang.html"; break;
	}
	// Get language-specific template, if available
	$nFullTmplPathLang = "tmpl/$nTmplPathLang";
	if(file_exists($nFullTmplPathLang) && is_file($nFullTmplPathLang)){
		$nTemplateCode = file_get_contents($nFullTmplPathLang);
	} else {
		// Get default template
		$nFullTmplPath = "tmpl/$nTmplPath";
		if(file_exists($nFullTmplPath) && is_file($nFullTmplPath)){ $nTemplateCode = file_get_contents($nFullTmplPath); } else {
			exit("Template does not exist: $nFullTmplPath. Please check your system configuration.");
		}
	}
	$nTemplateCode = tmplParse($nTemplateCode);
	if(!$nReqTagsAdded){ $nTemplateCode = tmplAddRequiredTags($nTemplateCode); }
	return $nTemplateCode;
}

function tmplAddRequiredTags($nTemplateCode){
	global $nReqTagsAdded,$nJSOnloadARRAY,$nRequiredAtBeginOfHeadARRAY,$nRequiredAtEndOfHeadARRAY,$nRequiredAtBeginOfBodyARRAY,$nRequiredAtEndOfBodyARRAY,$nFullSitePath,$nSSLSitePath,$_SERVER,$nPageID;
	if($_SERVER['HTTPS']==="on"){ $nFullSitePath=$nSSLSitePath; }
	
	// add required tags to end of body
	$nRequiredAtEndOfBodyARRAY[] = "<div id=\"status\" style=\"display:none;\"><table><tr><td class=\"padRight\"><img src=\"".$nFullSitePath."img/load.gif\" alt=\"\" width=\"16\" height=\"16\" border=\"0\"></td><td><div align=\"center\">Loading...<BR>Please wait<BR></div></td></tr></table></div>";
	
	/*
	if($_SERVER['HTTPS']!=="on"){ 
		$nRequiredAtBeginOfHeadARRAY[] = "<script type=\"text/javascript\" src=\"".$nFullSitePath."js/lightbox/lightbox.js\"></script>";
		$nRequiredAtBeginOfHeadARRAY[] = "<link rel=\"stylesheet\" href=\"".$nFullSitePath."css/lightbox.css\" type=\"text/css\" media=\"screen\" />";
		$nRequiredAtBeginOfHeadARRAY[] = "<link rel=\"stylesheet\" href=\"".$nFullSitePath."css/tooltip.css\" type=\"text/css\" media=\"screen\" />";
	}
	$nRequiredAtBeginOfHeadARRAY[] = "<script type=\"text/javascript\" src=\"".$nFullSitePath."js/utility.js\"></script>";
	$nRequiredAtBeginOfHeadARRAY[] = "<link rel=\"stylesheet\" href=\"".$nFullSitePath."tmpl/global.css\" type=\"text/css\" media=\"screen\" />";
	// add required tags to end of body
	$nRequiredAtEndOfBodyARRAY[] = "<div id=\"minicartNote\" style=\"display:none;\"><table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr><td><img src=\"".$nFullSitePath."img/note_top.gif\" alt=\"\" width=\"149\" height=\"8\" border=\"0\"></td></tr><tr><td align=\"center\" class=\"minicartNoteContent\">Item added to cart <a href=\"javascript:;\" onClick=\"hideMCNote();return false;\"><img src=\"".$nFullSitePath."img/note_close.gif\" alt=\"\" width=\"10\" height=\"10\" border=\"0\" style=\"margin:0px 0px -2px 10px;\"></a></td></tr><tr><td><img src=\"".$nFullSitePath."img/note_bot.gif\" alt=\"\" width=\"149\" height=\"3\" border=\"0\"></td></tr></table></div>";
	$nRequiredAtEndOfBodyARRAY[] = nGetAnalyticsCode();
	*/
	// add required tags to header and body
	//if(!$nTemplateCodeARRAY[1]){ exit("Head tag does not exist or does not properly close in your template. Please check and fix your template."); }
	
	// add required tags to head
	if($nRequiredAtBeginOfHeadARRAY){
		$nReqBeginHeadTags = implode("\n",$nRequiredAtBeginOfHeadARRAY);
		$nTemplateCode = preg_replace("/<head([A-Za-z0-9_ ><.:;\/#=\"'-]*)>/","<head$1>".$nReqBeginHeadTags,$nTemplateCode,1);
	}
	if($nRequiredAtEndOfHeadARRAY){
		$nTemplateCodeARRAY = explode("</head>",$nTemplateCode);
		$nTemplateCode = $nTemplateCodeARRAY[0].implode("\n",$nRequiredAtEndOfHeadARRAY)."</head>\n".$nTemplateCodeARRAY[1];
	}
	if($nRequiredAtEndOfBodyARRAY){
		$nTemplateCodeARRAY = explode("</body>",$nTemplateCode);
		$nTemplateCode = $nTemplateCodeARRAY[0].implode("\n",$nRequiredAtEndOfBodyARRAY)."</body>\n".$nTemplateCodeARRAY[1];
	}
	if($nJSOnloadARRAY){
		$nTemplateCodeARRAY = explode("<body",$nTemplateCode);
		$nTemplateCode = $nTemplateCodeARRAY[0]."<body onLoad=\"".implode("\n",$nJSOnloadARRAY)."\"".$nTemplateCodeARRAY[1];
	}
	// add required tags to beginning of body
	if($nRequiredAtBeginOfBodyARRAY){
		$nReqBeginBodyTags = implode("\n",$nRequiredAtBeginOfBodyARRAY);
		$nTemplateCode = preg_replace("/<body([A-Za-z0-9_ ><.:;\/#=\"'-]*)>/","<body$1>".$nReqBeginBodyTags,$nTemplateCode,1);
	}
	$nReqTagsAdded = 1;
	return $nTemplateCode;
}

function tmplParse($nTemplateCode,$nItemID="",$nItemType=""){
	global $nOpenerTag,$nCloserTag,$nTagParamDelim;
	if(!$nTemplateCode){ return ""; }
	// Parse elements
	do{
		$nOpenerPos = strpos($nTemplateCode,$nOpenerTag);
		$nCloserPos = strpos($nTemplateCode,$nCloserTag,$nOpenerPos);
		if($nOpenerPos!==false && $nCloserPos!==false){
			$nInnerTag = substr($nTemplateCode,($nOpenerPos+strlen($nOpenerTag)),($nCloserPos-strlen($nCloserTag)-$nOpenerPos));
			$nReplacement = "";
			$nInnerTagARRAY = explode($nTagParamDelim,$nInnerTag);
			$nTemplateItem = $nInnerTagARRAY[0];
			unset($nInnerTagARRAY[0]);
			switch($nTemplateItem){
				/* -------------- Components ----------------- */
				case "comp":
					$nReplacement = tmplGetComp($nTemplateItem,$nInnerTagARRAY);
					break;
				case "compColumnComps":
					$nReplacement = tmplGetColumnComps($nTemplateItem,$nInnerTagARRAY);
					break;
				case "compPageNav":
					$nReplacement = tmplGetCompPageNav($nTemplateItem,$nInnerTagARRAY);
					break;
				case "compProdList":
					$nReplacement = tmplGetCompProdList($nTemplateItem,$nInnerTagARRAY);
					break;
				case "compRelatedList":
					$nReplacement = tmplGetCompRelatedList($nTemplateItem,$nInnerTagARRAY);
					break;
				case "compLangNav":
					$nReplacement = tmplGetCompLangNav($nItemID,$nInnerTagARRAY);
					break;
				case "compSearchBox":
					$nReplacement = tmplCompSearchBox($nTemplateItem,$nInnerTagARRAY);
					break;
				case "compSearchResults":
					$nReplacement = tmplCompSearchRes($nTemplateItem,$nInnerTagARRAY);
					break;
				/* -------------- Content Items ----------------- */
				case "nPageBGColor":
					$nReplacement = tmplGetPageBGColor($nTemplateItem,$nInnerTagARRAY);
					break;
				case "nBGImagePath":
					$nReplacement = tmplGetPageBGImgPath($nTemplateItem,$nInnerTagARRAY);
					break;
				case "nPageBaseColor":
					$nReplacement = tmplGetPageBaseColor($nTemplateItem,$nInnerTagARRAY);
					break;
				case "nBackBGColor":
					$nReplacement = tmplGetPageBackBGColor($nTemplateItem,$nInnerTagARRAY);
					break;
				case "langChange":
					$nReplacement = tmplGetLangChange($nTemplateItem,$nInnerTagARRAY);
					break;
				case "text":
				case "pageName":
				case "pageTitle":
					$nReplacement = tmplGetPageName($nItemID,$nInnerTagARRAY);
					break;
				case "link":
				case "pageLinkPath":
					$nReplacement = tmplGetPageLinkPath($nItemID,$nInnerTagARRAY);
					break;
				
				case "pageClickPath":
					$nReplacement = tmplGetClickPath($nTemplateItem,$nInnerTagARRAY);
					break;
				case "linkCustomPage":
					$nReplacement = tmplGetLinkCustomPage($nTemplateItem,$nInnerTagARRAY);
					break;
				case "wordLanguage":
				case "wordHome":
					$nReplacement = tmplGetWord($nTemplateItem,$nInnerTagARRAY);
					break;
				/* -------------- General Items ----------------- */
				case "sitePath":
				case "siteSSLPath":
				case "siteTmplPath":
					$nReplacement = tmplGetPath($nTemplateItem,$nInnerTagARRAY);
					break;
				case "buttonPath":
					$nReplacement = tmplGetButtonPath($nTemplateItem,$nInnerTagARRAY);
					break;
				case "siteName":
					$nReplacement = tmplGetSiteName($nTemplateItem,$nInnerTagARRAY);
					break;
				case "siteTitle":
					$nReplacement = tmplGetSiteTitle($nTemplateItem,$nInnerTagARRAY);
					break;
				case "linkHome":
				case "linkCart":
					$nReplacement = tmplGetLink($nTemplateItem,$nInnerTagARRAY);
					break;
				case "searchFormOpen":
				case "searchFormClose":
				case "searchField":
					$nReplacement = tmplGetSearchItem($nTemplateItem,$nInnerTagARRAY);
					break;
				case "showDateTime":
					$nReplacement = tmplGetDateTime($nTemplateItem,$nInnerTagARRAY);
					break;
			}
			$nTemplateCode = str_replace(($nOpenerTag.$nInnerTag.$nCloserTag),$nReplacement,$nTemplateCode);
		}
	} while($nOpenerPos!==false);
	return $nTemplateCode;
}

/* ------ COMPONENT Template Functions ------ */

function tmplGetComp($nItem,$nFullParamARRAY=""){
	global $DBName,$Link,$nUserCompPath;
	$nRepeatType = "";
	$nCompFile = nGetParam("FILE",$nFullParamARRAY);
	$nCompFilePath = tmplGetPath("siteTmplPath",array("ABS=0","SSL=0"))."$nUserCompPath$nCompFile";
	if(file_exists($nCompFilePath)){ $nCompCode = file_get_contents($nCompFilePath); } else { return ""; }
	$nCompCode = tmplParse($nCompCode);
	return $nCompCode;
}

function tmplGetCompPageNav($nItem,$nFullParamARRAY=""){
	global $DBName,$Link,$nPageID,$nUserCompPath;
	$nCompFile = nGetParam("FILE",$nFullParamARRAY);
	$nCompActiveFile = nGetParam("FILE-ACTIVE",$nFullParamARRAY);
	$nShowSubs = nGetParam("SHOWSUBS",$nFullParamARRAY);
	$nCompSub = nGetParam("SUBCOMP",$nFullParamARRAY);
	$nFilterID = nGetParam("NAVID",$nFullParamARRAY);
	if(!$nFilterID){ $nFilterID=0; }
	if(!$nShowSubs){ $nShowSubs="no"; }
	$nCompFilePath = tmplGetPath("siteTmplPath",array("ABS=0","SSL=0"))."$nUserCompPath$nCompFile";
	$nCompActiveFilePath = tmplGetPath("siteTmplPath",array("ABS=0","SSL=0"))."$nUserCompPath$nCompActiveFile";
	$nCompSubFilePath = tmplGetPath("siteTmplPath",array("ABS=0","SSL=0"))."$nUserCompPath$nCompSub";
	if(!$nFilterID){ $nFilePath=$nCompFilePath; }
	$nActiveNavPageIDARRAY[] = $nPageID;
	if($nPageID){
		// get this page's section and parent first
		$Query = "SELECT nSectionID FROM nPage WHERE nID=$nPageID";
		$Result = mysql_db_query ($DBName,$Query,$Link);
		if($Row = mysql_fetch_array($Result)) {
			$nSectionID = $Row["nSectionID"];
			if($nSectionID){ $nActiveSectionARRAY[] = $nSectionID; }
		}
		// get any additional section parents, if any, for active highlights
		if($nSectionID){
			// add do/while loop here to get any additional parents
			$Query = "SELECT nParentID FROM nSection WHERE nID=$nSectionID LIMIT 1";
			$Result = mysql_db_query ($DBName,$Query,$Link);
			if($Row = mysql_fetch_array($Result)) {
				$nParentID = $Row["nParentID"];
				if($nParentID){ $nActiveSectionARRAY[] = $nParentID; }
			}
		}
	}
	$Query = "SELECT nID,nType FROM nPage WHERE nSectionID=$nFilterID ORDER BY nOrderID";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nType = $Row[nType];
		switch($nType){
			case "Search":
				$nTempCompCode = "[#compSearchBox#]";
				break;
			case "Homepage":
			case "Content":
			case "Link":
				if(array_search($Row["nID"],$nActiveNavPageIDARRAY)!==false && $nCompActiveFile){ $nFilePath=$nCompActiveFilePath; } else { $nFilePath=$nCompFilePath; } // for active items
				if(file_exists($nFilePath)){ $nTempCompCode = file_get_contents($nFilePath); } else { return ""; }
				break;
		}
		$nCompCode.=tmplParse($nTempCompCode,$Row["nID"],"cat");
	}
	return $nCompCode;
}

function tmplGetCompRelatedList($nItem,$nFullParamARRAY=""){
	global $DBName,$Link,$xProd,$pg,$nType,$nUserCompPath;
	$nCompFile = nGetParam("FILE",$nFullParamARRAY);
	$nCompFilePath = tmplGetPath("siteTmplPath",array("ABS=0","SSL=0"))."$nUserCompPath$nCompFile";
	$nProdID = nGetParam("PRODID",$nFullParamARRAY);
	$nFormat = nGetParam("FORMAT",$nFullParamARRAY);
	if($nFormat=="vert"){ $maxItemsPerRow=1; } else { $maxItemsPerRow=3; }
	if(!$nProdID){ $nProdID=$xProd; }
	if($nProdID && !is_numeric($nProdID)){ return; }
	$nRelatedARRAY = array("nRelated1","nRelated2","nRelated3");
	foreach($nRelatedARRAY as $nRelatedProd) {
		$Query = "SELECT $nRelatedProd AS nRelated FROM nProdInfo WHERE nID=$xProd LIMIT 1";
		$Result = mysql_db_query ($DBName,$Query,$Link);
		if ($Row = mysql_fetch_array($Result)) {
			$nRelated = $Row[nRelated];
			$nProdViewable = nGetProdIsViewable($nRelated);
			$nProdExists = nGetProdExists($nRelated);
			if($nProdViewable && $nProdExists){
				if(file_exists($nCompFilePath)){ $nTempCompCode = file_get_contents($nCompFilePath); } else { return ""; }
				$nProdARRAY[]=tmplParse($nTempCompCode,$nRelated,"prod");
			}
		}
	}
	$nCompCode = nTableizeArray($nProdARRAY,$maxItemsPerRow);
	if($nCompCode){ $nCompCode = "<strong>Related products:</strong><BR>$nCompCode"; }
	return $nCompCode;
}

function tmplGetColumnComps($nItem,$nFullParamARRAY=""){
	global $DBName,$Link,$nPageID;
	$nColumnID = nGetParam("COLID",$nFullParamARRAY);
	if(!$nColumnID || !$nPageID){ return; }
	$nSQL = "SELECT nComponentID,nContentID FROM xComponentPage LEFT JOIN nComponent ON nComponentID=nComponent.nID WHERE nComponent.nActive=1 AND nColumnID=$nColumnID AND nPageID=$nPageID ORDER BY nOrderID";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	while($Row = mysql_fetch_array($Result)){
		$nContentID = $Row["nContentID"];
		$nCompID = $Row["nComponentID"];
		$nCompTitle = nGetComponentName($nCompID);
		$nCompFile = nGetComponentFile($nCompID);
		$nCompCode.=tmplComp("",array("CID=$nContentID","CFILE=$nCompFile"));
	}
	return $nCompCode;
}

/* ------ COMPONENT (Template-defined) Template Functions ------ */

function tmplComp($nItem,$nFullParamARRAY=""){
	global $DBName,$Link,$nDefaultLang,$nSFLang,$nCompPath,$nUserCompPath,$nPageID;
	global $nOpenerTag,$nCloserTag,$nTagParamDelim;
	global $nAllFieldARRAY;
	
	$nContentID = nGetParam("CID",$nFullParamARRAY);
	$nCompFile = nGetParam("CFILE",$nFullParamARRAY);
	$nTranslateLang = nGetParam("LANG",$nFullParamARRAY); // override translation language
	
	$nFilePath = "$nCompPath$nCompFile";
	$nSiteTmplPath = tmplGetPath("siteTmplPath",array("ABS=0","SSL=0"));
	
	// Pull in component settings file
	$nAllFieldARRAY = array();
	if(file_exists($nFilePath)){ include($nFilePath); }
	
	// Get template
	$nTemplatePath = "$nCompPath$nTemplateFile";
	
	$nLangPath = "$nSFLang/";
	if($nName && file_exists($nFilePath) && file_exists($nTemplatePath)){
		if(file_exists($nTemplatePath)){ $nTemplateCode = file_get_contents($nTemplatePath); }
	}
	// Override with external template, if exists (in main components language folder, e.g. comp/en/)
	$nTemplateOverridePath = "$nCompPath$nLangPath$nTemplateFile";
	if($nTemplateFile && file_exists($nTemplateOverridePath)){ $nTemplateCode = file_get_contents($nTemplateOverridePath); }
	// Override with external template, if exists (in template components folder, e.g. tmpl/comp/)
	$nTemplateOverridePath = "$nSiteTmplPath$nUserCompPath$nTemplateFile";
	if($nTemplateFile && file_exists($nTemplateOverridePath)){ $nTemplateCode = file_get_contents($nTemplateOverridePath); }
	// Override with external template, if exists (in template components language folder, e.g. tmpl/comp/en/)
	$nTemplateOverridePath = "$nSiteTmplPath$nUserCompPath$nLangPath$nTemplateFile";
	if($nTemplateFile && file_exists($nTemplateOverridePath)){ $nTemplateCode = file_get_contents($nTemplateOverridePath); }
	
	if(!$nTemplateCode){ return; }
	
	// Get content to fill template
	$nContentARRAY = nGetContentARRAY($nContentID,$nTranslateLang,"comp");
	
	// Override certain special content (navigation) by looping through "addField" calls from comp config file
	$nFieldCalledARRAY = array();
	foreach($nAllFieldARRAY AS $nFieldARRAY){
		$nFieldCalledARRAY[$nFieldARRAY["nFldID"]]++;
		switch($nFieldARRAY["nFldID"]){
			case "link-Section":
				// process navigation
				$nNavPageIDARRAY = array();
				$nActiveNavPageIDARRAY = array();
				$nActiveNavSectionARRAY = array();
				$nTimesFldCalled = $nFieldCalledARRAY[$nFieldARRAY["nFldID"]];
				$nFilterID = $nContentARRAY[$nTimesFldCalled]["nLinkID"];
				if(!$nFilterID){ $nFilterID=0; }
				$Query = "SELECT nID FROM nPage WHERE nSectionID=$nFilterID ORDER BY nOrderID";
				$Result = mysql_db_query ($DBName,$Query,$Link);
				while ($Row = mysql_fetch_array($Result)) {
					$nNavPageIDARRAY[] = $Row["nID"];
				}
				$nActiveNavPageIDARRAY[] = $nPageID;
				break;
			case "link":
			case "link-Page":
				// process page link
				$nTimesFldCalled = $nFieldCalledARRAY[$nFieldARRAY["nFldID"]];
				if($nContentARRAY[$nTimesFldCalled]["nLinkID"]){
					$nContentARRAY[$nTimesFldCalled]["nLink"] = tmplGetPageLinkPath($nContentARRAY[$nTimesFldCalled]["nLinkID"]);
				}
				break;
		}
	}
	
	// Parse template
	do{
		$nOpenerPos = strpos($nTemplateCode,$nOpenerTag);
		$nCloserPos = strpos($nTemplateCode,$nCloserTag,$nOpenerPos);
		if($nOpenerPos!==false && $nCloserPos!==false){
			$nInnerTag = substr($nTemplateCode,($nOpenerPos+strlen($nOpenerTag)),($nCloserPos-strlen($nCloserTag)-$nOpenerPos));
			$nReplacement = "";
			$nInnerTagARRAY = explode($nTagParamDelim,$nInnerTag);
			$nTemplateItem = $nInnerTagARRAY[0];
			unset($nInnerTagARRAY[0]);
			
			switch($nTemplateItem){
				case "pageid":
					$nReplacement = $nPageID;
					break;
				case "compid":
					$nReplacement = $nContentID;
					break;
				case "text":
					$nNum = nGetParam("NUM",$nInnerTagARRAY); if(!$nNum){ $nNum=1; }
					$nBefore = nGetParam("BEFORE",$nInnerTagARRAY);
					$nAfter = nGetParam("AFTER",$nInnerTagARRAY);
					$nReplacement = $nContentARRAY[$nNum]["nText"];
					if($nReplacement){ $nReplacement = "$nBefore$nReplacement$nAfter"; }
					break;
				case "textarea":
					$nNum = nGetParam("NUM",$nInnerTagARRAY); if(!$nNum){ $nNum=1; }
					$nBefore = nGetParam("BEFORE",$nInnerTagARRAY);
					$nAfter = nGetParam("AFTER",$nInnerTagARRAY);
					$nReplacement = $nContentARRAY[$nNum]["nTextarea"];
					if($nReplacement){ $nReplacement = "$nBefore$nReplacement$nAfter"; }
					break;
				case "linkedtext":
					$nNum = nGetParam("NUM",$nInnerTagARRAY); if(!$nNum){ $nNum=1; }
					$nLinkNum = nGetParam("LINKNUM",$nInnerTagARRAY); if(!$nLinkNum){ $nLinkNum=1; }
					$nBefore = nGetParam("BEFORE",$nInnerTagARRAY);
					$nAfter = nGetParam("AFTER",$nInnerTagARRAY);
					$nShowUnlinked = nGetParam("SHOWUNLINKED",$nInnerTagARRAY);
					$nText = $nContentARRAY[$nNum]["nText"];
					$nNoText = nGetParam("NOTEXT",$nInnerTagARRAY);
					$nLink = $nContentARRAY[$nLinkNum]["nLink"];
					if($nNoText && !$nText){ $nText=$nNoText; }
					if($nLink && $nText){
						$nReplacement = "<a href=\"$nLink\">$nText</a>";
					} else {
						if($nShowUnlinked!=="0" && $nShowUnlinked!=="false"){ $nReplacement = $nText; }
					}
					if($nReplacement){ $nReplacement = "$nBefore$nReplacement$nAfter"; }
					break;
				case "linkedtextarea":
					$nNum = nGetParam("NUM",$nInnerTagARRAY); if(!$nNum){ $nNum=1; }
					$nLinkNum = nGetParam("LINKNUM",$nInnerTagARRAY); if(!$nLinkNum){ $nLinkNum=1; }
					$nBefore = nGetParam("BEFORE",$nInnerTagARRAY);
					$nAfter = nGetParam("AFTER",$nInnerTagARRAY);
					$nShowUnlinked = nGetParam("SHOWUNLINKED",$nInnerTagARRAY);
					$nText = $nContentARRAY[$nNum]["nTextarea"];
					$nNoText = nGetParam("NOTEXT",$nInnerTagARRAY);
					$nLink = $nContentARRAY[$nLinkNum]["nLink"];
					if($nNoText && !$nText){ $nText=$nNoText; }
					if($nLink && $nText){
						$nReplacement = "<a href=\"$nLink\">$nText</a>";
					} else {
						if($nShowUnlinked!=="0" && $nShowUnlinked!=="false"){ $nReplacement = $nText; }
					}
					if($nReplacement){ $nReplacement = "$nBefore$nReplacement$nAfter"; }
					break;
				case "image":
					$nNum = nGetParam("NUM",$nInnerTagARRAY); if(!$nNum){ $nNum=1; }
					$nBefore = nGetParam("BEFORE",$nInnerTagARRAY);
					$nAfter = nGetParam("AFTER",$nInnerTagARRAY);
					$nReplacement = nGetImageTagFromID($nContentARRAY[$nNum]["nImgID"]);
					if($nReplacement){ $nReplacement = "$nBefore$nReplacement$nAfter"; }
					break;
				case "linkedimage":
					$nNum = nGetParam("NUM",$nInnerTagARRAY); if(!$nNum){ $nNum=1; }
					$nLinkNum = nGetParam("LINKNUM",$nInnerTagARRAY); if(!$nLinkNum){ $nLinkNum=1; }
					$nBefore = nGetParam("BEFORE",$nInnerTagARRAY);
					$nAfter = nGetParam("AFTER",$nInnerTagARRAY);
					$nShowUnlinked = nGetParam("SHOWUNLINKED",$nInnerTagARRAY);
					$nImage = nGetImageTagFromID($nContentARRAY[$nNum]["nImgID"]);
					$nNoImage = nGetParam("NOIMAGE",$nInnerTagARRAY);
					$nLink = $nContentARRAY[$nLinkNum]["nLink"];
					if($nNoImage && !$nImage){ $nImage=$nNoImage; }
					if($nLink && $nImage){
						$nReplacement = "<a href=\"$nLink\">$nImage</a>";
					} else {
						if($nShowUnlinked!=="0" && $nShowUnlinked!=="false"){ $nReplacement = $nImage; }
					}
					if($nReplacement){ $nReplacement = "$nBefore$nReplacement$nAfter"; }
					break;
				case "link":
					$nNum = nGetParam("NUM",$nInnerTagARRAY); if(!$nNum){ $nNum=1; }
					$nBefore = nGetParam("BEFORE",$nInnerTagARRAY);
					$nAfter = nGetParam("AFTER",$nInnerTagARRAY);
					if($nNavPageIDARRAY){
						// navigation links
						$nNavCompFile = nGetParam("FILE",$nInnerTagARRAY);
						if($nNavCompFile){
							$nNavCompActiveFile = nGetParam("FILE-ACTIVE",$nInnerTagARRAY);
							$nNavCompFilePath = "$nCompPath$nNavCompFile";
							$nNavCompActiveFilePath = "$nCompPath$nNavCompActiveFile";
							// Override with external template, if exists
							$nNavCompOverridePath = $nSiteTmplPath."$nCompPath$nNavCompFile";
							if(file_exists($nNavCompOverridePath)){ $nNavCompFilePath = $nNavCompOverridePath; }
							$nNavCompActiveOverridePath = $nSiteTmplPath."$nCompPath$nNavCompActiveFile";
							if(file_exists($nNavCompActiveOverridePath)){ $nNavCompActiveFilePath = $nNavCompActiveOverridePath; }
						}
						foreach($nNavPageIDARRAY AS $nNavPageID){
							$nPageType = nGetPageType($nNavPageID);
							if(in_array($nNavPageID,$nActiveNavPageIDARRAY) && $nNavCompActiveFile){ $nNavFilePath=$nNavCompActiveFilePath; } else { $nNavFilePath=$nNavCompFilePath; } // for active items
							if(file_exists($nNavFilePath)){
								$nTempCompCode = file_get_contents($nNavFilePath);
							} else {
								$nTempCompCode = "<li><a href=\"[#link#]\">[#text#]</a></li>";
							}
							//if($nPageType=="Search"){ $nTempCompCode = "<li>*[#compSearchBox#]*</li>"; }
							$nTempCompCode = tmplParse($nTempCompCode,$nNavPageID,"comp");
							if($nTempCompCode){ $nReplacement.= $nTempCompCode; }
						}
					} else {
						// simple link
						$nReplacement = $nContentARRAY[$nNum]["nLink"];
					}
					if($nReplacement){ $nReplacement = "$nBefore$nReplacement$nAfter"; }
					break;
				default:
					// For tags not directly modified by components, temporarily hide it so it can be parsed later
					$nReplacement = "]#".$nInnerTag."#[";
			}
			$nTemplateCode = str_replace(($nOpenerTag.$nInnerTag.$nCloserTag),$nReplacement,$nTemplateCode);
		}
	} while($nOpenerPos!==false);
	
	// allow temporarily hidden tags to now be parsed
	$nTemplateCode = str_replace("]#","[#",$nTemplateCode);
	$nTemplateCode = str_replace("#[","#]",$nTemplateCode);
	
	$nCompCode = tmplParse($nTemplateCode);
	return $nCompCode;
}

// called from component files
function addField($nFldID="",$nTitle="",$nCaption="",$nDefVal="",$nFldStyle=""){
	global $nAllFieldARRAY;
	$nAllFieldARRAY[] = array("nFldID"=>$nFldID, "nTitle"=>$nTitle,"nCaption"=>$nCaption,"nDefVal"=>$nDefVal,"nFldStyle"=>$nFldStyle);
}

function nGetPageType($nPageID){
	global $DBName,$Link;
	if(!$nPageID){ return; }
	$nSQL = "SELECT nType FROM nPage WHERE nID=$nPageID LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nType = $Row["nType"];
	}
	return $nType;
}

function nGetContentARRAY($nContentID,$nTranslateLang="",$nType="comp"){
	global $DBName,$Link,$nDefaultLang,$nSFLang;
	if(!$nContentID || !is_numeric($nContentID)){ return; }
	if(!$nTranslateLang){ $nTranslateLang = $nSFLang; }
	$nContentARRAY = array();
	$Query = "SELECT * FROM nTranslate WHERE nItemID='$nContentID' AND nLang='$nTranslateLang' AND nType='$nType'";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	while($Row = mysql_fetch_array($Result)) {
		$nOrderID = $Row["nOrderID"];
		$nContentCompARRAY = array();
		$nContentCompARRAY["nText"] = stripslashes($Row[nText]);
		$nContentCompARRAY["nTextarea"] = stripslashes($Row[nTextarea]);
		$nContentCompARRAY["nLinkID"] = stripslashes($Row[nLinkID]);
		$nContentCompARRAY["nImgID"] = $Row["nImgID"];
		// HTML conversion of any intl characters
		$nContentCompARRAY["nText"] = nConvertIntChars($nContentCompARRAY["nText"]);
		$nContentCompARRAY["nTextarea"] = nConvertIntChars($nContentCompARRAY["nTextarea"]);
		// Get default language text to fill in all content gaps
		if($nTranslateLang!=$nDefaultLang){
			$nDefContentARRAY = nGetContentARRAY($nContentID,$nDefaultLang,$nType);
			if(!$nContentCompARRAY["nText"]){ $nContentCompARRAY["nText"] = nConvertIntChars($nDefContentARRAY[$nOrderID]["nText"]); }
			if(!$nContentCompARRAY["nTextarea"]){ $nContentCompARRAY["nTextarea"] = nConvertIntChars($nDefContentARRAY[$nOrderID]["nTextarea"]); }
			if(!$nContentCompARRAY["nLinkID"]){ $nContentCompARRAY["nLinkID"] = $nDefContentARRAY[$nOrderID]["nLinkID"]; }
			if(!$nContentCompARRAY["nImgID"]){ $nContentCompARRAY["nImgID"] = $nDefContentARRAY[$nOrderID]["nImgID"]; }
		}
		// Add to main array
		$nContentARRAY[$nOrderID] = $nContentCompARRAY;
	}
	return $nContentARRAY;
}

// COMP: Search Box, optional: TRLBR
function tmplCompSearchBox($nItem,$nFullParamARRAY=""){
	global $DBName,$Link,$nSearch;
	$nNumBRs = nGetParam("TRLBR",$nFullParamARRAY);
	if($nNumBRs){ while($nNumBRs){ $nTrlBRs.="<BR>";$nNumBRs--; } }
	if($nSearch){ $nSearchValue = $nSearch; } else { $nSearchValue = "SEARCH"; }
	$nCompCode = <<<CODE
	<!-- BEGIN COMP: Search field //-->
	<form action="search.php" method="get" name="nSearchForm" id="nSearchForm" style="float:left;margin:0px;"><input type="text" name="nSearch" value="$nSearchValue" size="10" maxlength="25" class="searchInput" onFocus="clearSearch(this);" onBlur="revertSearch(this);"></form>
	<a href="javascript:document.nSearchForm.submit();"> &gt;&gt; </a>
CODE;
	return $nCompCode;
}

// COMP: Search Box, optional: TRLBR
function tmplCompSearchRes($nItem,$nFullParamARRAY=""){
	global $DBName,$Link,$xCat,$pg,$nSearchSQL,$nSearch;
	if(!$pg){ $pg=1; }
	if(!$nSearchSQL){ $nSearchSQL = nGetContentSearchSQL($nSearch); }
	// build results table
	$nShowPerPage = nGetShowPerPg();
	$nTotalRecords = nGetTotalResults($nSearch);
	$nStartRecord = nGetStartRecord();
	$nEndRecord = nGetEndRecord($nTotalRecords);
	// init vars/arrays
	$nItemARRAY = array();
	// items per row for this design
	$maxItemsPerRow = 1;
	$nLRDividerStyle = nGetParam("DIVRGHT",$nFullParamARRAY);
	$nTBDividerStyle = nGetParam("DIVBOTT",$nFullParamARRAY);
	$nCurrentProd = 1;
	if(!$nTotalRecords){ return "<div align=\"center\"><BR><BR>We're sorry...no content containing '<strong>$nSearch</strong>' found.<BR><BR>Please make sure all you search keywords are spelled correctly,<BR>or retry your search using fewer or broader keywords!<BR><BR><BR></div>"; }
	$Result = mysql_db_query ($DBName,$nSearchSQL,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		if($nCurrentProd<=$nTotalRecords){
			// do only if products to show per page, and page number match
			if($nStartRecord<=$nCurrentProd && $nCurrentProd<=$nEndRecord){
				$nItemIDARRAY[] = $Row["nID"];
			}
			$nCurrentProd++;
		}
	}
	// display products, or if needed, sort them
	if($nItemIDARRAY){
		foreach($nItemIDARRAY as $nItemID){ $nItemARRAY[]="<li>".nGetContentBrief($nItemID); }
		$nCompCode = "<ol style=\"margin-left:20px;\">".implode("<BR>",$nItemARRAY)."</ol>";
	}
	// Get additional search results
	$nPageNameResults = nGetPageNameSearchRes($nSearch);
	if($nPageNameResults){ $nPageNameResults=$nPageNameResults."<BR>"; }
	if($nCompCode){ $nResHeader = "<span class=\"caption\">Your search for '<strong>$nSearch</strong>' returned <strong>$nEndRecord result(s)</strong>.</span><BR><BR>"; }
	$nCompCode = "$nResHeader $nPageNameResults <div style=\"border:1px solid #CDCDCD;padding:8px 10px 10px 10px\"><strong>Search results:</strong><BR><BR> $nCompCode<BR></div>";
	return $nCompCode;
}

function nGetContentBrief($nTranslateID){
	global $DBName,$Link;
	if(!$nTranslateID || !is_numeric($nTranslateID)){ return; }
	$Query = "SELECT nItemID,nText,nTextarea FROM nTranslate WHERE nID=$nTranslateID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nContentID = $Row["nItemID"];
		$nText = stripslashes($Row["nText"]);
		$nTextarea = stripslashes($Row["nTextarea"]);
	}
	$nText = nConvertIntChars($nText); // HTML conversion of any intl characters
	$nTextarea = nConvertIntChars($nTextarea); // HTML conversion of any intl characters
	if($nText || $nTextarea){
		// Get link to page where content shows (yeah, it can show up on more than one page, i know, just getting first for now...)
		$nPageLinkID = nGetFirstPageIDFromContentID($nContentID);
		$nPageLinkPath = tmplGetPageLinkPath($nPageLinkID);
		if($nText){ $nText="<h2><a href=\"$nPageLinkPath\">$nText</a></h2>"; }
		$nCompCode = <<<CODE
		<div onClick="document.location.href='$nPageLinkPath'" style="cursor:hand;">$nText $nTextarea</div><BR>
CODE;
	}
	return $nCompCode;
}
function nGetFirstPageIDFromContentID($nContentID){
	global $DBName,$Link;
	if(!$nContentID || !is_numeric($nContentID)){ return; }
	$Query = "SELECT nPageID FROM xComponentPage WHERE nContentID=$nContentID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nPageID = $Row["nPageID"];
	}
	return $nPageID;
}

function tmplGetCompLangNav($nItem,$nFullParamARRAY=""){
	global $DBName,$Link,$nSFLang,$nDefaultLang,$nUserCompPath;
	$nLangCodeARRAY = array();
	$nLangARRAY = nGetLangActiveARRAY();
	if(count($nLangARRAY)<=1){ return; } // if only one language, just return
	$nCompFile = nGetParam("FILE",$nFullParamARRAY);
	$nCompFilePath = tmplGetPath("siteTmplPath",array("ABS=0","SSL=0"))."$nUserCompPath$nCompFile";
	if(file_exists($nCompFilePath)){ $nTempCompCode = file_get_contents($nCompFilePath); } else { return ""; }
	$nCompCode=tmplParse($nTempCompCode);
	return $nCompCode;
}

/* ------ INDIVIDUAL ITEM Template Functions ------ */

/* --- GENERAL --- */
function tmplGetPageBGColor($nItem,$nFullParamARRAY=""){
	global $DBName,$Link,$nPageID,$_GET;
	if(!$nPageID){ $nPageID=$_GET["id"]; }
	if(!$nPageID || !is_numeric($nPageID)){ return; }
	$Query = "SELECT nBGColor AS nColor FROM nPage WHERE nID=$nPageID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nColor = $Row["nColor"];
	}
	return $nColor;
}

function tmplGetPageBGImgPath($nItem,$nFullParamARRAY=""){
	global $DBName,$Link,$nPageID,$_GET;
	if(!$nPageID){ $nPageID=$_GET["id"]; }
	if(!$nPageID || !is_numeric($nPageID)){ return; }
	$Query = "SELECT nBGImgID FROM nPage WHERE nID=$nPageID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nBGImgID = $Row["nBGImgID"];
	}
	if($nBGImgID){ $nBGImgPath = nGetImagePathFromID($nBGImgID); }
	return $nBGImgPath;
}

function tmplGetPageBaseColor($nItem,$nFullParamARRAY=""){
	global $DBName,$Link,$nPageID,$_GET;
	if(!$nPageID){ $nPageID=$_GET["id"]; }
	if(!$nPageID || !is_numeric($nPageID)){ return; }
	$Query = "SELECT nBaseColor AS nColor FROM nPage WHERE nID=$nPageID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nColor = $Row["nColor"];
	}
	return $nColor;
}

function tmplGetPageBackBGColor($nItem,$nFullParamARRAY=""){
	global $DBName,$Link,$nPageID,$_GET;
	if(!$nPageID){ $nPageID=$_GET["id"]; }
	if(!$nPageID || !is_numeric($nPageID)){ return; }
	$Query = "SELECT nBackBGColor AS nColor FROM nPage WHERE nID=$nPageID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nColor = $Row["nColor"];
	}
	return $nColor;
}

function tmplGetPath($nPathToGet,$nFullParamARRAY=""){
	global $nFullSitePath,$nSSLSitePath,$nTmplPath,$nType,$_SERVER;
	$nUseAbsolutePath = nGetParam("ABS",$nFullParamARRAY);
	$nUseSecure = nGetParam("SSL",$nFullParamARRAY);
	switch($nPathToGet){
		case "sitePath": $nPath = $nFullSitePath; break;
		case "siteSSLPath": $nPath = $nSSLSitePath; break;
		case "siteTmplPath":
			$nPath = "tmpl/".nRemoveFileName($nTmplPath);
			if($nUseAbsolutePath!=="0"){
				if($nUseSecure){
					$nPath = $nSSLSitePath.$nPath;
				} else {
					if($_SERVER['HTTPS']=="on" && $nUseSecure!=="0"){
						$nPath = $nSSLSitePath.$nPath; //force secure abs path on secure pages
					} else {
						$nPath = $nFullSitePath.$nPath;
					}
				}
			}
			break;
	}
	return $nPath;
}

// Utility functions
function nGetComponentName($nRecID){
	global $DBName,$Link;
	$nSQL = "SELECT nName FROM nComponent WHERE nID='$nRecID' LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nName = $Row["nName"];
	}
	return $nName;
}
function nGetComponentFile($nRecID){
	global $DBName,$Link;
	$nSQL = "SELECT nCompFile FROM nComponent WHERE nID='$nRecID' LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nCompFile = $Row["nCompFile"];
	}
	return $nCompFile;
}
function nGetContentSearchResultsARRAY($nSearch){
	global $DBName,$Link,$nDefaultLang,$nSFLang;
	if(!$nSearch){ return; }
	if($nSFLang){ $nLangClause = "AND nLang='$nSFLang' AND nType='comp'"; }
	$nPageIDResultsARRAY = array(); // holds pure results
	$nPageIDRelevanceARRAY = array(); // holds results (key) with relevance (value).. higher # = higher relevance
	$nSearchFieldsARRAY = array("nText","nTextarea");
	// SEARCH exact phrase (strict)
	$where_clauses = array();
	foreach($nSearchFieldsARRAY AS $nSearchField){ $where_clauses[] = "$nSearchField regexp '{$nSearch}'"; }
	$where_clause = " WHERE (" . join ("\n   OR ", $where_clauses).")";
	$Query = "SELECT nID FROM nTranslate $where_clause $nLangClause";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$nTotalResults = mysql_num_rows($Result);
	while ($Row = mysql_fetch_array($Result)) {
		$nID = $Row["nID"]; $nPageIDResultsARRAY[] = $nID;
		if(array_key_exists($nID,$nPageIDRelevanceARRAY)){ $nPageIDRelevanceARRAY[$nID]++; } else { $nPageIDRelevanceARRAY[$nID] = 1; }
	}
	// SEARCH exact phrase (liberal)
	$Query = "SELECT nID FROM nTranslate WHERE MATCH (".implode(",",$nSearchFieldsARRAY).") AGAINST('$nSearch') $nLangClause";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$nTotalResults = mysql_num_rows($Result);
	while ($Row = mysql_fetch_array($Result)) {
		$nID = $Row["nID"]; $nPageIDResultsARRAY[] = $nID;
		if(array_key_exists($nID,$nPageIDRelevanceARRAY)){ $nPageIDRelevanceARRAY[$nID]++; } else { $nPageIDRelevanceARRAY[$nID] = 1; }
	}
	// SEARCH by individual word (strict)
	$nSearchTermARRAY = array();
	$nSearchTermARRAY = explode(" ",$nSearch);  // split on whitespace
	foreach ($nSearchTermARRAY as $term){
	    $Query = "SELECT nID FROM nTranslate WHERE MATCH (".implode(",",$nSearchFieldsARRAY).") AGAINST('$term') $nLangClause";
		$Result = mysql_db_query ($DBName,$Query,$Link);
		$nTotalResults = mysql_num_rows($Result);
		while ($Row = mysql_fetch_array($Result)) {
			$nID = $Row["nID"]; $nPageIDResultsARRAY[] = $nID;
			if(array_key_exists($nID,$nPageIDRelevanceARRAY)){ $nPageIDRelevanceARRAY[$nID]++; } else { $nPageIDRelevanceARRAY[$nID] = 1; }
		}
	}
	// SEARCH by individual word (liberal)
	$nSearchTermARRAY = array();
	$nSearchTermARRAY = explode(" ",$nSearch);  // split on whitespace
	foreach ($nSearchTermARRAY as $term){
	    $where_clauses = array();
		foreach($nSearchFieldsARRAY AS $nSearchField){ $where_clauses[] = "$nSearchField regexp '{$term}'"; }
		$where_clause = " WHERE (" . join ("\n   OR ", $where_clauses).")";
		$Query = "SELECT nID FROM nTranslate $where_clause $nLangClause";
		$Result = mysql_db_query ($DBName,$Query,$Link);
		$nTotalResults = mysql_num_rows($Result);
		while ($Row = mysql_fetch_array($Result)) {
			$nID = $Row["nID"]; $nPageIDResultsARRAY[] = $nID;
			if(array_key_exists($nID,$nPageIDRelevanceARRAY)){ $nPageIDRelevanceARRAY[$nID]++; } else { $nPageIDRelevanceARRAY[$nID] = 1; }
		}
	}
	// SEARCH by individual word (VERY liberal)
	$terms = preg_split("/\s+/", $nSearch);  // split on whitespace
	$where_clauses = array();
	foreach ($terms as $term){
	    $where_clauses = array();
		foreach($nSearchFieldsARRAY AS $nSearchField){ $where_clauses[] = "$nSearchField LIKE '%{$term}%'"; }
	}
	$where_clause = " WHERE (" . join ("\n   OR ", $where_clauses).")";
	$Query = "SELECT nID FROM nTranslate $where_clause $nLangClause";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$nTotalResults = mysql_num_rows($Result);
	while ($Row = mysql_fetch_array($Result)) {
		$nID = $Row["nID"]; $nPageIDResultsARRAY[] = $nID;
		if(array_key_exists($nID,$nPageIDRelevanceARRAY)){ $nPageIDRelevanceARRAY[$nID]++; } else { $nPageIDRelevanceARRAY[$nID] = 1; }
	}
	// final sorting
	arsort($nPageIDRelevanceARRAY,SORT_NUMERIC);
	return $nPageIDRelevanceARRAY;
}
function nGetPageNameSearchRes($nSearch){
	global $DBName,$Link,$nSFLang,$nDefaultLang;
	if(!$nSearch){ return ""; }
	
	if($nSFLang){ $nLangClause = "AND nLang='$nSFLang' AND nType='page'"; }
	$nCurrRow=1;
	$nColumnAmount=3;
	$nWidthPercent = round(100/$nColumnAmount);
	$nTable = "";
	$nPageIDFoundARRAY = array();
	
	$Query = "SELECT nID,nItemID,nText FROM nTranslate WHERE (nText LIKE '%".$nSearch."%') $nLangClause";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$nTotalResults = mysql_num_rows($Result);
	while ($Row = mysql_fetch_array($Result)) {
		if($nCurrRow==1){ $nTable .= "<tr>"; }
		$nID = $Row["nID"];
		$nPageID = $Row["nItemID"];
		$nText = nConvertIntChars($Row["nText"]);
		$nPageLinkPath = tmplGetPageLinkPath($nPageID);
		$nTable .= "<td width=\"$nWidthPercent%\" valign=\"top\" class=\"content\" style=\"padding-right:10px;\"><ul><li><a href=\"$nPageLinkPath\">$nText</a></ul></td>";
		if ($nColumnAmount == $nCurrRow) { $nTable.="</tr>";$nCurrRow=1; } else { $nCurrRow++; }
	}
	// Open table
	$nOpener=<<<CODE
<div style="border:1px solid #CDCDCD;padding:8px 10px 10px 10px">
	<table width="88%" border="0" cellspacing="0" cellpadding="0">
	  <tr><td colspan="$nColumnAmount" class="content" style="padding-bottom:12px "><b>Full pages matching your search:</b></td></tr>
CODE;
	// Close table
	$nCloser="</tr></table></div>";
	if($nTable){ $nTable="$nOpener$nTable$nCloser"; }
	return $nTable;
}
function nGetContentSearchSQL($nSearch){
	global $DBName,$Link,$nDefaultLang,$nSFLang;
	if($nSFLang){ $nLangClause = "AND nLang='$nSFLang' AND nType='comp'"; }
	$nSearchResultsARRAY = nGetContentSearchResultsARRAY($nSearch); // returns ID (key) with relevance (value), ordered by highest relevance
	if($nSearchResultsARRAY){ foreach($nSearchResultsARRAY as $key => $item ){ $nFinalSearchResultsARRAY[]=$key; } } else { return; }// move keys to values
	$nOrderByList = "ORDER BY "; // Get correct order output (next 3 lines)
	if($nFinalSearchResultsARRAY){ foreach($nFinalSearchResultsARRAY as $nContentID){ $nOrderByList .= "nID=$nContentID DESC, ";  } } else { return; }
	$nOrderByList = rtrim($nOrderByList,", ");
	$Query = "SELECT nID FROM nTranslate WHERE nID IN (".implode(",",$nFinalSearchResultsARRAY).") $nLangClause $nOrderByList";
	return $Query;
}
function nGetTotalResults($nSearch){
	global $DBName,$Link;
	// Get total number of items
	$nTotalItems = 0;
	$nIDsAlreadyUsed = "";
	$nSearchSQL = nGetContentSearchSQL($nSearch);
	if(!$nSearchSQL){ return 0; }
	$Result = mysql_db_query ($DBName,$nSearchSQL,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nTotalItems++;
		if($nIDsAlreadyUsed!=""){ $nIDsAlreadyUsed .= ",$Row[nID]"; } else { $nIDsAlreadyUsed = "$Row[nID]"; }
	}
	return $nTotalItems;
}
function nGetStartRecord(){
	global $DBName,$Link,$pg;
	$nShowPerPage = nGetShowPerPg();
	$nStartRecord = ($nShowPerPage*($pg-1))+1;
	return $nStartRecord;
}
function nGetEndRecord($nTotalRecords){
	global $DBName,$Link,$pg;
	$nShowPerPage = nGetShowPerPg();
	$nEndRecord = $nShowPerPage*$pg;
	// Return smaller of the two
	if ($nEndRecord>$nTotalRecords){return $nTotalRecords;} else {return $nEndRecord;}
}
function nGetShowPerPg(){
	return 20;
}
function nGetImageTagFromID($nImgID){
	global $DBName,$Link,$nJSOnloadARRAY;
	$nSQL = "SELECT nPath,nPathOver FROM nImage WHERE nID='$nImgID' LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nPath = $Row["nPath"];
		$nPathOver = $Row["nPathOver"];
	}
	$nImgTag = nGetImgTag($nPath);
	if($nPathOver){ $nJSOnloadARRAY[]="new Rollover('img$nImgID');"; }
	return $nImgTag;
}
function nGetImagePathFromID($nImgID){
	global $DBName,$Link;
	$nSQL = "SELECT nPath FROM nImage WHERE nID='$nImgID' LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nPath = $Row["nPath"];
	}
	return $nPath;
}
function nGetImgTag($nImgFile){
	$nSitePath = tmplGetPath("sitePath");
	if(!$nImgFile){ return; }
	if(file_exists("$nImgFile")){
		$nImgTagARRAY = getimagesize($nImgFile);
		$nImgTagWH = $nImgTagARRAY[3];
	}
	$nTag = "<img src=\"$nSitePath$nImgFile\" alt=\"\" $nImgTagWH border=\"0\">";
	return $nTag;
}
















function tmplGetButtonPath($nButtonToGet,$nFullParamARRAY=""){
	global $nSFLang;
	if(!$nButtonToGet){ return; }
	$nTemplatePath = tmplGetPath("siteTmplPath");
	$nNonSSLTemplatePath = tmplGetPath("siteTmplPath",array("ABS=0","SSL=0"));
	// internationalization
	$nIntlButtonPath = $nTemplatePath."buttons/".$nSFLang."/".$nButtonToGet;
	$nNonSSLButtonPath = $nNonSSLTemplatePath."buttons/".$nSFLang."/".$nButtonToGet;
	$nDefaultButtonPath = $nTemplatePath."buttons/".$nButtonToGet;
	if(file_exists("$nNonSSLButtonPath")){ $nButtonPath = "$nIntlButtonPath"; } else {  $nButtonPath = "$nDefaultButtonPath";}
	return $nButtonPath;
}

function tmplGetClickPath($nItem,$nFullParamARRAY=""){
	global $DBName,$Link,$nType,$_GET;
	global $nFullSitePath;
	$nPathDelim = "&raquo;";
	$nMaxWords = nGetParam("WRD",$nFullParamARRAY);
	$nPageTitle = tmplGetPageName($nItem);
	// if category or product, get parent...
	if($nType===0 || $nType==10){
		if(!$nCatID){ $nCatID=$_GET["xCat"]; }
		if(!$nCatID || !is_numeric($nCatID)){ return; }
		if($nCatID){
			if($nType===0){
				$Query = "SELECT nParent AS nParent FROM nCatInfo WHERE nID=$nCatID LIMIT 1";
				$Result = mysql_db_query ($DBName,$Query,$Link);
				if($Row = mysql_fetch_array($Result)){
					$nParentID = $Row["nParent"];
				}
			}
			if($nType==10){ $nParentID = $nCatID; }
			if($nParentID){
				$nParentName = tmplGetPageName($nParentID);
				$nParentLink = tmplGetPageLinkPath($nParentID);
				if($nMaxWords){
					$nMaxChars = $nMaxWords*6; // limit characters based on avg word size
					$nParentName = nTruncateText($nParentName,$nMaxWords,$nMaxChars);
				}
				$nParent = "<a href=\"$nParentLink\"$nClass>$nParentName</a> $nPathDelim";
			}
		}
	}
	$nClass = nGetParam("CLASS",$nFullParamARRAY);
	if($nClass){ $nClass = " class=\"$nClass\""; }
	// Setup links
	$nHomeLink = tmplGetLink("linkHome");
	$wordHome = tmplGetWord("wordHome");
	$nClickPath = "<a href=\"$nHomeLink\"$nClass>$wordHome</a> $nPathDelim $nParent $nPageTitle";
	if($nClass){ $nClickPath = "<span$nClass>$nClickPath</span>"; }
	return $nClickPath;
}

function tmplGetLinkCustomPage($nLinkToGet,$nFullParamARRAY=""){
	global $nFullSitePath,$nSSLSitePath;
	$nCode = strtolower(nGetParam("ID",$nFullParamARRAY));
	$nPageName = nGetParam("NAME",$nFullParamARRAY);
	$nLink = "page.php?id=$nCode&pg=$nPageName";
	$nUseSecure = nGetParam("SSL",$nFullParamARRAY);
	if($nUseSecure){ return $nSSLSitePath.$nLink; }
	$nLink = $nFullSitePath.$nLink;
	return $nLink;
}

function tmplGetWord($nWordToGet,$nFullParamARRAY=""){
	global $wordLanguage,$wordHome;
	
	switch($nWordToGet){
		case "wordLanguage": $nWord=$wordLanguage; break;
		case "wordHome": $nWord=$wordHome; break;
	}
	$nWord = nConvertIntChars($nWord); // HTML conversion of any intl characters
	return $nWord;
}

function tmplGetLink($nLinkToGet,$nFullParamARRAY=""){
	global $nFullSitePath,$nSSLSitePath;
	switch($nLinkToGet){
		case "linkHome": return $nFullSitePath; break;
		case "linkCart": $nLink = "cart.php?nReferrer=$nThisPage"; break;
		case "linkAccount": $nLink = "welcome.php"; $nUseSecure=1; break;
		case "linkContact": $nLink = "contact.php"; break;
		case "linkProdNew": $nLink = "catnew.php"; break;
		case "linkProdSale": $nLink = "catsale.php"; break;
		case "linkProdBest": $nLink = "catbest.php"; break;
		case "linkPrivacy": $nLink = "privacy.php"; break;
		case "linkTerms": $nLink = "terms.php"; break;
		case "linkShipping": $nLink = "shipping.php"; break;
		case "linkAbout": $nLink = "about_us.php"; break;
		case "linkFriends": $nLink = "friends.php"; break;
		case "linkTestimonials": $nLink = "testimonials.php"; break;
		case "linkLogin": $nLink = "customer_login.php"; $nUseSecure=1; break;
		case "linkLogout": $nLink = "process_logout.php"; break;
	}
	if(!$nUseSecure){ $nUseSecure = nGetParam("SSL",$nFullParamARRAY); }
	if($nUseSecure){ return $nSSLSitePath.$nLink; }
	$nLink = $nFullSitePath.$nLink;
	return $nLink;
}

function tmplGetSiteName($nLinkToGet,$nFullParamARRAY=""){
	global $nSettingsARRAY;
	$nSiteName = $nSettingsARRAY["siteName"];
	return $nSiteName;
}

function tmplGetSiteTitle($nLinkToGet,$nFullParamARRAY=""){
	global $nSettingsARRAY;
	$nSiteTitle = $nSettingsARRAY["coName"];
	return $nSiteTitle;
}

function tmplGetDateTime($nLinkToGet,$nFullParamARRAY=""){
	$nFormat = nGetParam("FORMAT",$nFullParamARRAY);
	if(!$nFormat){ $nFormat = "standard"; } //default
	switch($nFormat){
		case "year": $nDateTime = date("Y"); break;
		case "standard": $nDateTime = date("n/j/y"); break;
		case "fullText": $nDateTime = date("l, F dS, Y"); break;
		case "time": $nDateTime = date("h:i:sA"); break;
	}
	return $nDateTime;
}

/* --- SEARCH --- */

function tmplGetSearchItem($nSearchItem,$nFullParamARRAY=""){
	global $nFullSitePath,$nSearch;
	$nSearchFieldClass = nGetParam("CLASS",$nFullParamARRAY);
	switch($nSearchItem){
		case "searchFormOpen":
			$nSearchPath = $nFullSitePath."search.php";
			$nSearchCode="<form action=\"$nSearchPath\" method=\"get\" name=\"nSearchForm\" id=\"nSearchForm\" style=\"margin:0px;\">";
			break;
		case "searchFormClose": $nSearchCode="</form>"; break;
		case "searchField":
			$nSearchCode="<input type=\"text\" name=\"nSearch\" value=\"$nSearch\" name=\"nSearch\" maxlength=\"50\" class=\"$nSearchFieldClass\">";
			break;
	}
	return $nSearchCode;
}

/* --- MINI STUFF --- */
function tmplGetMiniCart($nItem,$nFullParamARRAY=""){
	global $nMemCartFormat,$nCurrencyFormat,$nCurrencyDecPt,$nCurrencyThousSep;
	$wordItems = strtolower(tmplGetWord("wordItems"));
	$wordItem = strtolower(tmplGetWord("wordItem"));
	$nIsAjaxCall = nGetParam("AJAXCALL",$nFullParamARRAY);
	
	$nProdAmount = nGetCartProdsAmount();
	$nCartTotal = nGetCartTotal();
	// format curreny (internationalization)
	$nCartTotalCurr = number_format($nCartTotal, 2, $nCurrencyDecPt, $nCurrencyThousSep);
	$nCartTotalText = str_replace("[nPrice]",$nCartTotalCurr,$nCurrencyFormat);
	if(!$nMemCartFormat){
		$nFormat = nGetParam("FORMAT",$nFullParamARRAY);
		if(!$nFormat){ $nFormat="standard"; } // Default format
		$nMemCartFormat = $nFormat; // memorize cart format for later calls to this function with format (i.e. AJAX)
	} else {
		$nFormat = $nMemCartFormat;
	}
	if($nProdAmount==1){ $nItemAmountText = $wordItem; } else { $nItemAmountText = $wordItems; }
	switch($nFormat){
		case "slim":
			$nMiniCartCode = "$nProdAmount $nItemAmountText, $nCartTotalText";
			break;
		case "standard":
			$nMiniCartCode = "$nProdAmount $nItemAmountText, Total: $nCartTotalText";
			break;
	}
	if(!$nIsAjaxCall){ $nMiniCartCode="<span id=\"ajaxMinicart\" style=\"position:relative\">$nMiniCartCode</span>"; } //if not a call from Ajax itself, set a ID for this minicart (for Ajax to use)
	return $nMiniCartCode;
}

function tmplGetAcceptCCImg($nItem,$nFullParamARRAY=""){
	global $DBName,$Link;
	$nUseAbsolutePath = nGetParam("ABS",$nFullParamARRAY);
	if($nUseAbsolutePath!=="0"){ $nHomeLink = tmplGetLink("linkHome"); }
	$Query = "SELECT * FROM nCartPrefs";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		if($Row["nAcceptVisa"]){ $nVisa="<td><img src=\"$nHomeLink/img/accept_visa.gif\" alt=\"Proudly accepting Visa&reg; cards\" width=\"27\" height=\"17\" border=\"0\" style=\"margin-right: 2px;\"></td>"; }
		if($Row["nAcceptMC"]){ $nMC="<td><img src=\"$nHomeLink/img/accept_mc.gif\" alt=\"Proudly accepting MasterCard&reg;\" width=\"27\" height=\"17\" border=\"0\" style=\"margin-right: 2px;\"></td>"; }
		if($Row["nAcceptAmex"]){ $nAmex="<td><img src=\"$nHomeLink/img/accept_amex.gif\" alt=\"Proudly accepting American Express&reg; Cards\" width=\"27\" height=\"17\" border=\"0\" style=\"margin-right: 2px;\"></td>"; }
		if($Row["nAcceptDiscover"]){ $nDiscover="<td><img src=\"$nHomeLink/img/accept_disc.gif\" alt=\"Proudly accepting Discover&reg; Card\" width=\"27\" height=\"17\" border=\"0\" style=\"margin-right: 2px;\"></td>"; }
		if($Row["nAcceptPaypal"]){ $nPaypal="<td><img src=\"$nHomeLink/img/accept_paypal.gif\" alt=\"Proudly accepting payments through PayPal&reg;\" width=\"50\" height=\"17\" border=\"0\" style=\"margin-right: 2px;\"></td>"; }
	}
	$nCCImgCode = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr>$nVisa$nMC$nAmex$nDiscover$nPaypal</tr></table>";
	return $nCCImgCode;
}

function tmplGetMiniLogin($nItem,$nFullParamARRAY=""){
	global $nFullSitePath,$nSSLSitePath,$_SESSION;
	$wordLogin = tmplGetWord("wordLogin");
	
	$nCustUser = $_SESSION["nSessValidCust"];
	$nCustName = $_SESSION["nSessName"];
	$nUseAcctLink = 1;
	if($nCustUser=="Guest"){ $nUseAcctLink = 0; }
	if($nCustName && strlen($nCustName)>10){ $nCustName = substr($nCustName,0,8)."..."; }
	$nFormat = nGetParam("FORMAT",$nFullParamARRAY);
	$nLinkAccount = tmplGetLink("linkAccount");
	$nLinkLogin = tmplGetLink("linkLogin");
	$nLinkLogout = tmplGetLink("linkLogout");
	if(!$nFormat){ $nFormat="standard"; } // Default format
	if($nUseAcctLink){ $nCustName="<a href=\"$nLinkAccount\">$nCustName</a>"; } else { $nCustName="$nCustName"; }
	switch($nFormat){
		case "slim":
			$nLoggedInCode = $nCustName."&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"$nLinkLogout\">Logout</a>";
		  	$nLoggedOutCode = "<a href=\"$nLinkLogin\">$wordLogin</a>";
			break;
		case "standard":
			$nLoggedInCode = "Currently logged in as:<BR>$nCustName | <a href=\"$nLinkLogout\">Logout</a>";
		  	$nLoggedOutCode = "Not logged in: <a href=\"$nLinkLogin\">$wordLogin</a>";
			break;
	}
	if($nCustUser){ $nMiniLoginCode = $nLoggedInCode; } else { $nMiniLoginCode = $nLoggedOutCode; }
	return $nMiniLoginCode;
}

function tmplGetLangChange($nItem,$nFullParamARRAY=""){
	global $nThisPage,$nFullSitePath,$nSSLSitePath,$nSFLang,$_SERVER;
	$nLangCodeARRAY = array();
	$nLangARRAY = nGetLangActiveARRAY();
	// Get homepage path
	//if($_SERVER['HTTPS']==="on"){ $nSitePath=$nSSLSitePath; } else { $nSitePath=$nFullSitePath; }
	//if(strpos($nThisPage,$nSitePath)===false){ $nPagePath = $nSitePath.$nThisPage; }
	//$nPagePath = str_replace("~~","?",$nPagePath);
	//$nPagePath = str_replace("~","&",$nPagePath);
	// Get this page path
	$nPagePath = $_SERVER["REQUEST_URI"];
	// create HTML (drop out currently selected language, not needed)
	foreach($nLangARRAY as $nLangCode => $nLangName){
		if($nLangCode!=$nSFLang){
			if(strpos($nPagePath,"?")!==false){ $nPagePath.="&sfl=$nLangCode"; } else { $nPagePath.="?sfl=$nLangCode"; }
			$nLangCodeARRAY[]="<a href=\"$nPagePath\">$nLangName</a>";
		}
	}
	$nFormat = nGetParam("FORMAT",$nFullParamARRAY);
	if(!$nFormat){ $nFormat="standard"; } // Default format
	switch($nFormat){
		case "slim":
			$nLangCode = implode("&nbsp;&nbsp;|&nbsp;&nbsp;",$nLangCodeARRAY);
			break;
		case "standard":
			$nLangCode = implode("<BR>",$nLangCodeARRAY);
			break;
		case "full":
			$nLangCode = implode("&nbsp;&nbsp;|&nbsp;&nbsp;",$nLangCodeARRAY);
			$nLangCode = tmplGetWord("wordLanguage").": $nLangCode";
			break;
	}
	return $nLangCode;
}

// Returns page name based on any array of parameters passed in
function tmplGetPageName($nPID,$nFullParamARRAY=""){
	global $DBName,$Link,$nDefaultLang,$nSFLang,$nPageID;
	if(!$nPID){ $nPID=$nPageID; }
	if(!$nPID || !is_numeric($nPID)){ return; }
	$Query = "SELECT nNavTitle FROM nPage WHERE nID=$nPID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nPageName = $Row[nNavTitle];
	}
	$nPageName = stripslashes($nPageName);
	$nPageName = str_replace("\"","&quot;",$nPageName);
	$nMaxWords = nGetParam("WRD",$nFullParamARRAY);
	if($nMaxWords){
		$nMaxChars = $nMaxWords*6; // limit characters based on avg word size
		$nPageName = nTruncateText($nPageName,$nMaxWords,$nMaxChars);
	}
	
	$nTranslateType="page"; $nTranslateID=$nPID;
	// if translation is needed...
	$nTranslateLang = nGetParam("LANG",$nFullParamARRAY); // override translation language
	if(!$nTranslateLang){ $nTranslateLang = $nSFLang; } // if no override, use session language
	$nTranslation = nGetTranslation($nTranslateLang,$nTranslateID,"nText",$nTranslateType);
	if($nTranslation){ $nPageName = $nTranslation; }
	
	$nPageName = nConvertIntChars($nPageName); // HTML conversion of any intl characters
	return $nPageName;
}

// Returns page link path based on any array of parameters passed in
function tmplGetPageLinkPath($nPageID,$nFullParamARRAY=""){
	global $DBName,$Link,$nDefaultLang,$nSFLang;
	global $nFullSitePath;
	if(!$nPageID){ return; }
	
	$nSQL = "SELECT nType,nTitle,nNavTitle FROM nPage WHERE nID=$nPageID LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nType = $Row["nType"];
		$nTitle = $Row["nTitle"];
		$nNavTitle = $Row["nNavTitle"];
	}
	
	$nTranslateType="page"; $nTranslateID=$nPageID;
	// if translation is needed...
	$nTranslateLang = nGetParam("LANG",$nFullParamARRAY); // override translation language
	if(!$nTranslateLang){ $nTranslateLang = $nSFLang; } // if no override, use session language
	$nTranslation = nGetTranslation($nTranslateLang,$nTranslateID,"nText",$nTranslateType);
	if($nTranslation){ $nNavTitle = $nTranslation; }
	
	switch($nType){
		case "Homepage": $nPagePath = $nFullSitePath; break;
		case "Content":
			$nPageNameForPath = nPrepareNameForPath($nNavTitle); // for mod-rewrite
			$nPagePath = $nPageID."/".$nPageNameForPath.".html"; // for mod-rewrite
			$nPagePath = $nFullSitePath.$nPagePath;
			//$nPagePath = $nFullSitePath."content.php?id=$nPageID";
			break;
		case "Search": $nPagePath = $nFullSitePath."search.php"; break;
		case "Link":
			// get link extension
			$nLinkInfo = pathinfo($nTitle);
			$nLinkExt = strtolower($nLinkInfo[extension]);
			$nSitePathARRAY = parse_url($nFullSitePath);
			$nLinkARRAY = parse_url($nTitle);
			// if the link is external or to a PDF, open in new window
			if(isExternalLink($nTitle) || $nLinkExt=="pdf"){
				$nPagePath = $nTitle."\" target=\"newWin\" onclick=\"PopUp(this.href,this.target,800,600,1);";
			} else {
				$nPagePath = $nTitle;
			}
			break;
	}
	return $nPagePath;
}

/* ------ OTHER Needed Functions ------ */

function nGetParam($nParamToGet,$nFullParamARRAY){
	if($nFullParamARRAY){
		foreach($nFullParamARRAY as $nParam) {
			$nParamARRAY = explode("=",$nParam,2); // explode, just getting the first '=' in array so user can add their own in params and not mess things up
			if($nParamARRAY[0]==$nParamToGet){ $nParamValue = $nParamARRAY[1]; }
		}
	}
	return $nParamValue;
}
function nGetFileName($nPath){
	$nPathARRAY = explode("/",$nPath);
	// make a duplicate of the last array item
	$nFileName = array_pop($nPathARRAY);
	return $nFileName;
}
function nRemoveFileName($nPath){
	$nPathARRAY = explode("/",$nPath);
	// make a duplicate of the last array item
	$nFileName = array_pop($nPathARRAY);
	$nPath = implode("/",$nPathARRAY);
	if(!$nPath){ return; }
	return $nPath."/";
}
function nGetGroupTitle($nGroupID){
	global $DBName,$Link;
	if(!$nGroupID){ return ""; }
	$Query = "SELECT nGroupName FROM nGroupInfo WHERE nID=$nGroupID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)){
		$nGroupName = stripslashes($Row[nGroupName]);
	}
	return $nGroupName;
}
function nGetProdOptionPriceIncCount($xProd){
	global $DBName,$Link;
	$nCount = 0;
	// Get options info from database for this product, and find those that increase the price of the product variations
	$Query = "SELECT nProdOption1Name,nProdOption1Set,nProdOption2Name,nProdOption2Set,nProdOption3Name,nProdOption3Set,nProdOption4Name,nProdOption4Set,nProdOption5Name,nProdOption5Set FROM nProdInfo WHERE nID=$xProd LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if($Row = mysql_fetch_array($Result)){
		if($Row[nProdOption1Name] && $Row[nProdOption1Set]){
			$pos = strpos($Row[nProdOption1Set],"_");
			if($pos!==false){ $nCount++; }
		}
		if($Row[nProdOption2Name] && $Row[nProdOption2Set]){
			$pos = strpos($Row[nProdOption2Set],"_");
			if($pos!==false){ $nCount++; }
		}
		if($Row[nProdOption3Name] && $Row[nProdOption3Set]){
			$pos = strpos($Row[nProdOption3Set],"_");
			if($pos!==false){ $nCount++; }
		}
		if($Row[nProdOption4Name] && $Row[nProdOption4Set]){
			$pos = strpos($Row[nProdOption4Set],"_");
			if($pos!==false){ $nCount++; }
		}
		if($Row[nProdOption5Name] && $Row[nProdOption5Set]){
			$pos = strpos($Row[nProdOption5Set],"_");
			if($pos!==false){ $nCount++; }
		}
	}
	return $nCount;
}
function nGetRandomHomeProd(){
	global $DBName,$Link;
	$Query = "SELECT nHomeLinkCat AS nID FROM nHomeContent ORDER BY RAND() LIMIT 0,1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nProdID = $Row[nID];
	}
	return $nProdID;
}
function nCatIsContentOnly($nID) {
	global $DBName, $Link;
	if(!$nID){ return; }
	$Query = "SELECT nContentOnly FROM nCatInfo WHERE nID=$nID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nIsContentOnly = $Row[nContentOnly];
	}
	if ($nIsContentOnly=="FALSE"){ $nIsContentOnly=0; }
	return $nIsContentOnly;
}
function nCatGetChildrenCount($nID) {
	global $DBName, $Link;
	$nCount = 0;
	$Query = "SELECT nID FROM nCatInfo WHERE nParent=$nID";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nCount++;
	}
	return $nCount;
}
function nGetProdExists($nProdID){
  global $DBName,$Link;
	if(!$nProdID){ return; }
	$Query = "SELECT nID FROM nProdInfo WHERE nID=$nProdID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$Row = mysql_fetch_array($Result);
	return $Row[nID];
}
function nGetCatIsViewable($nCatID){
	global $DBName,$Link;
	if(!$nCatID){ return; }
	$nCatActive = 1;
	$Query = "SELECT nCatActive FROM nCatInfo WHERE nID=$nCatID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$Row = mysql_fetch_array($Result);
	$nCatActive = $Row[nCatActive];
	return $nCatActive;
}
function nGetGroupIsViewable($nGrpID){
	global $DBName,$Link;
	if(!$nGrpID){ return; }
	$nGroupActive = 1;
	$Query = "SELECT nGroupActive FROM nGroupInfo WHERE nID=$nGrpID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$Row = mysql_fetch_array($Result);
	$nGroupActive = $Row[nGroupActive];
	return $nGroupActive;
}
function nGetProdIsViewable($nProdID){
	global $DBName,$Link;
	global $nSessCustType,$xCat;
	if(!$nProdID){ return; }
	$nAccessGranted = 0;
	// First, check if this category is active
	if($xCat && !nGetCatIsViewable($xCat)){ return 0; }
	// Next, check if the current customer has access the product
	$Query = "SELECT nScopeType FROM nProdInfo WHERE nID=$nProdID";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nScopeType = $Row[nScopeType];
	}
	// If not logged in, consider this customer of the General type
	if(!$nSessCustType){ $nSessCustType=1; }
	$nScopeTypeArray = explode(",",$nScopeType);
	// if customer type (or general type) appears in scope of this category, give access
	if (in_array("1",$nScopeTypeArray) || in_array($nSessCustType,$nScopeTypeArray) || !$nScopeType) {
		$nAccessGranted = 1;
	}
	// Check to see if this product is in inventory
	if(nGetUsingInvRemove($nProdID) && nGetProdOutOfInv($nProdID)){ return 0; }
	return $nAccessGranted;
}
function nGetHasFeatProd($nCatID){
	global $DBName,$Link;
	if(!$nCatID){ return; }
	$Query = "SELECT nID FROM nProdInfo WHERE nCat=$nCatID AND nFeatured=1 AND nProdAvail!=0 LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nHasFeaturedProd = 1;
	}
	return $nHasFeaturedProd;
}
function nGetProdPrice($nProdID,$nUseSalePrice){
	global $DBName,$Link;
	global $nSessCustType;
	// If not logged in, consider this customer of the General type
	if(!$nSessCustType){ $nSessCustType=1; }
	if($nUseSalePrice){ $nGetField = "nSalePrice"; } else { $nGetField = "nPrice"; }
	$nProdPrice = "";
	// First, check to see if there is a price specific to this customer type for this product
	$Query = "SELECT $nGetField AS nPrice FROM nProdPriceInfo WHERE nCustTypeID=$nSessCustType AND nProdID=$nProdID";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nProdPrice = $Row[nPrice];
	}
	// If no price was found for the customer type, use the default price
	if($nProdPrice==""){
		if($nUseSalePrice){ $nGetField = "nSalePrice"; } else { $nGetField = "nProdPrice"; }
		$Query = "SELECT $nGetField AS nProdPrice FROM nProdInfo WHERE nID=$nProdID";
		$Result = mysql_db_query ($DBName,$Query,$Link);
		if ($Row = mysql_fetch_array($Result)) {
			$nProdPrice = $Row[nProdPrice];
		}
	}
	return $nProdPrice;
}
function nGetPurchaseAllowed($nProdID){
	global $DBName,$Link;
	if(!$nProdID){ return; }
	// if product is a case, use it's parent
	$Query = "SELECT nCaseParentID FROM nProdInfo WHERE nID=$nProdID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if($Row = mysql_fetch_array($Result)){
		if($Row[nCaseParentID]){ $nProdID = $Row[nCaseParentID]; }
	}
	$Query = "SELECT nAllowPurchase FROM nProdInfo WHERE nID=$nProdID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$Row = mysql_fetch_array($Result);
	$nAllowPurchase = $Row[nAllowPurchase];
	return $nAllowPurchase;
}

function nGetTotalProd(){
	global $DBName,$Link,$pg,$nProdListSQL;
	// Get total number of products
	$nTotalProds = 0;
	$nIDsAlreadyUsed = "";
	if(!$nProdListSQL){ $nProdListSQL = nGetProdListSQL(); }
	if(!$nProdListSQL){ return 0; }
	$Result = mysql_db_query ($DBName,$nProdListSQL,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nProdViewable = nGetProdIsViewable($Row[nID]);
		$nCatViewable = nGetCatIsViewable($Row[nCat]);
		// just show if product is viewable to this customer type...
		if($nProdViewable && $nCatViewable){
			$nTotalProds++;
			if($nIDsAlreadyUsed!=""){ $nIDsAlreadyUsed .= ",$Row[nID]"; } else { $nIDsAlreadyUsed = "$Row[nID]"; }
		}
	}
	return $nTotalProds;
}
function nGetProdCount($nCatID){
	global $DBName,$Link;
	// Get total number of products
	$nTotalProds = 0;
	$Query = "SELECT nID,nCat FROM nProdInfo WHERE nCat=$nCatID AND nProdAvail!=0 AND nCaseParentID=0";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nProdViewable = nGetProdIsViewable($Row[nID]);
		$nCatViewable = nGetCatIsViewable($Row[nCat]);
		// just show if product is viewable to this customer type...
		if($nProdViewable && $nCatViewable){
			$nTotalProds++;
		}
	}
	return $nTotalProds;
}
function nGetPaging(){
	global $DBName,$Link;
	$Query = "SELECT nShowPagingType FROM nCatPrefs";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$Row = mysql_fetch_array($Result);
	return $Row[nShowPagingType];
}
function nGetRecPerPage(){
	global $DBName,$Link;
	$Query = "SELECT nShowPerPage FROM nCatPrefs";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$Row = mysql_fetch_array($Result);
	return $Row[nShowPerPage];
}
function nCatHasFeature($nCatID){
	global $DBName,$Link;
	if(!$nCatID){ return; }
	$Query = "SELECT nID FROM nProdInfo WHERE nFeatured=1 AND nProdAvail!=0 AND nCat=$nCatID";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nProdID = $Row[nID];
	} else { return; }
	if(nGetUsingInvRemove($nProdID) && nGetProdOutOfInv($nProdID)){ return; }
	return $nProdID;
}
// return array of product IDs for any category
function nGetCatProdIDArray($nCatID){
	global $DBName,$Link;
	if(!$nCatID){ return; }
	// Get total number of products
	$nProdIDARRAY = array();
	$Query = "SELECT nID FROM nProdInfo WHERE nCat=$nCatID AND nProdAvail!=0 AND nCaseParentID=0";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nProdViewable = nGetProdIsViewable($Row[nID]);
		// just add if product is viewable to this customer type...
		if($nProdViewable){ $nProdIDARRAY[] = $Row[nID]; }
	}
	return $nProdIDARRAY;
}
function nTableizeArray($nArrayToProcess,$nColumnAmount="",$nLRDividerStyle="",$nTBDividerStyle=""){
	if(!$nArrayToProcess){ return; }
	$nHeader = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" style=\"$nTBDividerStyle\">";
	$nFooter = "</table>";
	$nItemAmount = count($nArrayToProcess);
	if(!$nColumnAmount){ $nColumnAmount=3; } //default
	$nAmountPerColumn = round($nItemAmount/$nColumnAmount);
	$nWidthPercent = round(100/$nColumnAmount);
	if($nItemAmount<$nColumnAmount){ $nAmountPerColumn=1; }
	$nCurrRow=1;
	foreach ($nArrayToProcess as $nItem) {
		if($nCurrRow==1){ $nTable.="$nHeader<tr>"; }
		if($nCurrRow<$nColumnAmount){ $LRStyle = $nLRDividerStyle; } else { $LRStyle = ""; }
		$nTable.="<td width=\"$nWidthPercent%\" valign=\"top\" style=\"$LRStyle\">$nItem</td>";
		if ($nColumnAmount == $nCurrRow) { $nTable.="</tr>$nFooter";$nCurrRow=1; } else { $nCurrRow++; }
	}
	if($nCurrRow!=1){
		// fill in final cells if table is unfinished
		while($nColumnAmount>=$nCurrRow){
			$nTable.="<td width=\"$nWidthPercent%\">&nbsp;</td>";
			if ($nColumnAmount == $nCurrRow) { $nTable.="</tr>$nFooter"; }
			$nCurrRow++;
		}
	}
	return $nTable;
}
// Inventory functions
function nGetProdQuantity($xProd){
	global $DBName,$Link;
	$Query = "SELECT nProdQuantity FROM nProdInventory WHERE nProdId=$xProd LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$Row = mysql_fetch_array($Result);
	$nProdQuantity = $Row[nProdQuantity];
	return "$nProdQuantity";
}
function nGetProdThreshold($xProd){
	global $DBName,$Link;
	$Query = "SELECT nProdThreshold FROM nProdInventory WHERE nProdId=$xProd LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$Row = mysql_fetch_array($Result);
	$nProdThreshold = $Row[nProdThreshold];
	return "$nProdThreshold";
}
function nGetProdOutOfInv($xProd){
	// This function returns TRUE (1) if a product is either at 0 in inventory,
	// or if it is below it's product threshold,
	// ONLY if the product uses InvControl,
	// otherwise it returns FALSE (0)
	if(nGetUsingInvControl($xProd)){
		$nProdQuantity = nGetProdQuantity($xProd);
		$nProdThreshold = nGetProdThreshold($xProd);
		if(($nProdQuantity - $nProdThreshold)<=0){ return 1; }
	}
	return 0; // NOT out of inventory
}
function nGetUsingInvControl($xProd){
	if(!$xProd){ return 0; }
	global $DBName,$Link;
	$Query = "SELECT nProdId FROM nProdInventory WHERE nProdId=$xProd LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$Row = mysql_fetch_array($Result);
	$nProdId = $Row[nProdId];
	if($nProdId){ return 1; } else { return 0; }
}
function nGetUsingInvRemove($xProd){
	if(!$xProd){ return 0; }
	global $DBName,$Link;
	$Query = "SELECT nProdRemove FROM nProdInventory WHERE nProdId=$xProd LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$Row = mysql_fetch_array($Result);
	$nProdRemove = $Row[nProdRemove];
	if($nProdRemove){ return 1; } else { return 0; }
}
// Receives text string, returns formatted string (unspecified HTML removed, HTML line breaks added, optional: double spacing converted to single)
function nMakePresentable($nTextToFormat,$nAllowDoubleSpacing="1",$nRemoveCR="1",$nConvertNewLineToBR="1"){
	$nAllowedTags = "<h1><h2><h3><h4><h5><h6><strong><em><b><i><a><ul><li><pre><hr><blockquote><img><div><p><table><tr><td><br><span><font><object><embed><script>";
	$nFormattedText = strip_tags(stripslashes($nTextToFormat),$nAllowedTags);
	if($nRemoveCR){ $nFormattedText = str_replace("\r","",$nFormattedText); } else { $nFormattedText = str_replace("\r","<BR>",$nFormattedText); }
	if($nConvertNewLineToBR){ $nFormattedText = str_replace("\n","<BR>",$nFormattedText); }
	if(!$nAllowDoubleSpacing){ $nFormattedText = str_replace("<BR><BR>","<BR>",$nFormattedText); }
	return $nFormattedText;
}
// Receives text string, returns truncated string (allows only x words, with max. y chars, truncates rest and adds closer)
function nTruncateText($nTextToTruncate,$nWordCountAllowed,$nMaxChars,$nCloser="..."){
	$nWordCount = 0;
	$nTruncatedText = $nTextToTruncate;
	$nAddCloser=0;
	if(strlen($nTruncatedText)>$nMaxChars){
		$nTruncatedText = trim(substr($nTruncatedText,0,$nMaxChars));
		$nAddCloser=1;
	}
	$nTextARRAY = explode(" ",$nTruncatedText);
	if(count($nTextARRAY)>$nWordCountAllowed){
		$nTruncatedText="";
		foreach($nTextARRAY as $nWord){
			$nWordCount++;
			if($nWordCount<=$nWordCountAllowed){
				$nTruncatedText.="$nWord ";
			}
		}
		$nAddCloser=1;
	}
	if($nAddCloser){ $nTruncatedText.=$nCloser; }
	return $nTruncatedText;
}

function parseDynamicFile($nFile){
	ob_start();
	include($nFile);
	$nBuffer = ob_get_contents();
	ob_end_clean();
	$nBuffer = tmplParse($nBuffer);
	return $nBuffer;
}
function nGetProdOptionsCount($nProdID){
	global $DBName,$Link;
	if(!$nProdID){ return; }
	$nCount = 0;
	// Get options info from database for this product
	$Query = "SELECT nProdOption1Name,nProdOption1Set,nProdOption2Name,nProdOption2Set,nProdOption3Name,nProdOption3Set,nProdOption4Name,nProdOption4Set,nProdOption5Name,nProdOption5Set FROM nProdInfo WHERE nID=$nProdID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if($Row = mysql_fetch_array($Result)){
		if($Row[nProdOption1Name] && $Row[nProdOption1Set]){ $nCount++; }
		if($Row[nProdOption2Name] && $Row[nProdOption2Set]){ $nCount++; }
		if($Row[nProdOption3Name] && $Row[nProdOption3Set]){ $nCount++; }
		if($Row[nProdOption4Name] && $Row[nProdOption4Set]){ $nCount++; }
		if($Row[nProdOption5Name] && $Row[nProdOption5Set]){ $nCount++; }
	}
	return $nCount;
}
function nGetProdShowAsList($nProdID){
	global $DBName,$Link;
	if(!$nProdID){ return; }
	$Query = "SELECT nShowAsList FROM nProdInfo WHERE nID=$nProdID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nShowAsList = $Row[nShowAsList];
	}
	return $nShowAsList;
}
function nGetProdImgE($nProdID){
	global $DBName,$Link;
	if(!$nProdID){ return; }
	$Query = "SELECT nProdImgE FROM nProdInfo WHERE nID=$nProdID LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$Row = mysql_fetch_array($Result);
	$nProdImgE = $Row[nProdImgE];
	return $nProdImgE;
}
function nPrepareNameForPath($nName){
	if(!$nName){ return; }
	$nName = str_replace(" ","-",$nName);
	$nRemoveARRAY = array(".",",",";",":","'","!","$","#","?","&","*","%","@","(",")","/","\\","<",">");
	$nName = str_replace($nRemoveARRAY,"",$nName);
	$nName = str_replace("--","-",$nName);
	$nName = nRemoveIntChars($nName);
	$nName = nConvertIntChars($nName);
	return $nName;
}

$nRandNumArray = array();
function nGetRandomNum($nNum){
	global $nRandNumArray;
	// Get a random ID number for this option set, 
	// but look to see if it's already been asked for first
	// if so, then just send that back
	if(!$nRandNumArray["$nNum"]){
		$nRandNumArray["$nNum"] = get_rand_letters(5);
	}
	return $nRandNumArray["$nNum"];
}

function get_rand_letters($length) { 
	$alphanum = array("", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"); 
	if($length>0) { 
		$rand_id=""; 
		for($i=1; $i<=$length; $i++) { 
			mt_srand((double)microtime() * 1000000); 
			$num = mt_rand(1,52); 
			$rand_id .= assign_rand_value($num, $alphanum); 
		}
	}
	return $rand_id; 
}

function assign_rand_value($num, $alphanums) { 
	// accepts 1 - 62 (1-52 alpha, 53-62 numeric) 
	$rand_value = $alphanums[$num]; 
	return $rand_value; 
}

function nGetCatIDFromProd($nProd){
	global $DBName,$Link;
	$Query = "SELECT nCat FROM nProdInfo WHERE nID=$nProd LIMIT 1";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nCat = $Row[nCat];
	}
	return $nCat;
}

function nGetGrpIDFromProd($nProdID,$nParentID){
	global $DBName,$Link;
	$Query = "SELECT nGroupName,nGroupID,nParentID FROM nProdGroup,nGroupInfo WHERE nGroupInfo.nID=nProdGroup.nGroupID AND nProdGroup.nProdID=$nProdID AND nGroupInfo.nParentID=$nParentID ORDER BY nGroupInfo.nDisplayOrder";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nGrpIDARRAY[] = $Row[nGroupID];
	}
	return $nGrpIDARRAY;
}

// receives a multi-dimensional array, sorts by inner array size, preserving all keys
function sortByCount($nARRAY){
	// make an array that holds (key of 1st array to sort) => (count of sub-array)
	$nTempARRAY = array();
	foreach($nARRAY as $nKey => $nSubARRAY){
		$nTempARRAY["$nKey"] = count($nSubARRAY);
	}
	array_multisort($nTempARRAY,SORT_DESC,$nARRAY);
	return $nARRAY;
}

function nGetGroupActive($nGroupID){
	global $DBName, $Link;
	$Query = "SELECT nGroupActive FROM nGroupInfo WHERE nID=$nGroupID";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if($Row = mysql_fetch_array($Result)) {
		$nActive = $Row[nGroupActive];
	}
	return $nActive;
}

// returns array of active storefront languages in alpha order, default will be first item in list 
function nGetLangActiveARRAY(){
	global $nDefaultLang;
	$nDefaultLangARRAY = array();
	$nLangARRAY = array();
	// Get all files in directory
	$path = "lang/";    
	$dir_handle = @opendir($path) or die("Unable to open $path");    
	while ($file = readdir($dir_handle)) {
		if($file == "." || $file == ".." || $file == "index.php" )
			continue;
		$nFileCode = str_replace(".php","",$file);
		if(!is_dir("$path$file/")){
			if(file_exists("$path$file")){ require("$path$file"); }
			if($nFileCode == $nDefaultLang){
				if($nLang){ $nDefaultLangARRAY["$nFileCode"] = $nLang; } // default language
			} else {
				if($nLang){ $nLangARRAY["$nFileCode"] = $nLang; }
			}
		}
	}
	closedir($dir_handle);
	// sorting, and add default to top of list
	krsort($nLangARRAY);
	foreach($nDefaultLangARRAY as $nLangCode => $nLangName) {
		$nLangARRAY["$nLangCode"] = $nLangName;
	}
	$nLangARRAY = array_reverse($nLangARRAY,true);
	return $nLangARRAY;
}
function nGetTranslation($nLangCode,$nItemID,$nField,$nType){
	global $DBName,$Link;
	if(!$nLangCode || !$nItemID || !$nField || !$nType){ return; }
	$Query = "SELECT $nField AS nField FROM nTranslate WHERE nLang='$nLangCode' AND nItemID='$nItemID' AND nType='$nType'";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nTranslation = $Row[nField];
	}
	return $nTranslation;
}
function nGetCartQuickAdd(){
	global $DBName,$Link;
	// Get cart preference: nCartQuickAdd
	$Query = "SELECT nCartQuickAdd FROM nCartPrefs";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nCartQuickAdd = $Row["nCartQuickAdd"];
	}
	return $nCartQuickAdd;
}
function nConvertIntChars($nText){
	if(!$nText){ return; }
	// lowercase
	$nText = str_replace("","&uacute;",$nText);
	$nText = str_replace("","&iacute;",$nText);
	$nText = str_replace("","&oacute;",$nText);
	$nText = str_replace("","&eacute;",$nText);
	$nText = str_replace("","&aacute;",$nText);
	$nText = str_replace("","&ntilde;",$nText);
	// uppercase
	$nText = str_replace("","&Uacute;",$nText);
	$nText = str_replace("","&Iacute;",$nText);
	$nText = str_replace("","&Oacute;",$nText);
	$nText = str_replace("","&Eacute;",$nText);
	$nText = str_replace("","&Aacute;",$nText);
	$nText = str_replace("","&Ntilde;",$nText);
	return $nText;
}

function nRemoveIntChars($nText){
	if(!$nText){ return; }
	$search = explode(",",",,,,,,,,,,,,,,,,,,,,,,,,,e,i,,u,,,,,,");
	$replace = explode(",","c,ae,oe,a,e,i,o,u,a,e,i,o,u,a,e,i,o,u,y,a,e,i,o,u,a,e,i,o,u,U,I,O,E,A,N");
	$nText = str_replace($search, $replace, $nText);
	return $nText;
}

function isExternalLink($nLink){
	global $nFullSitePath;
	if(!$nLink){ return; }
	$nSitePathARRAY = parse_url($nFullSitePath);
	$nLinkARRAY = parse_url($nLink);
	// if "http" exists, now search deeper
	if($nLinkARRAY[scheme]){
		$nSitePathHost = str_replace("www.","",$nSitePathARRAY[host]);
		$nLinkHost = str_replace("www.","",$nLinkARRAY[host]);
		// if link host name is not the same as the site's host name, this is an external link
		if($nSitePathHost!=$nLinkHost){ return true; }
	}
	return false;
}
?>
