<?php
/*
 * This file is part of Web Pro Manager.
 * 
 * Web Pro Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Web Pro Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Web Pro Manager.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author The Web Pro Miami, Inc. <info@thewebpro.com>
 * @copyright The Web Pro Miami, Inc. <info@thewebpro.com>, http://www.thewebpro.com/
 * @license http://www.gnu.org/licenses/gpl.html GNU GPL
 * @package WebProManager
*/

require("../inc/stop_cache.php");
$nAdminOnlyPg = 0;
require("../inc/secure_page.php");
// connect to mysql
require("../../inc/dbconnect.php");
require("../../inc/config.php");
require("../inc/langutil.php");

// config
$nRefreshCall = "refreshParentsPageAdd();";

// pull in all active languages (used to create multiple fields, when needed)
$nActiveLangARRAY = nGetLangActiveARRAY();

// Get passed-in vars
$nRecID = $_GET["id"];
if(!$nRecID){ $nRecID = $_POST["id"]; }

// AJAX Specific vars
$nPassThru = "";
$nDivToUpdate = "editModal";
$nPageInDiv = "{$nFullSitePath}manage/dialog/page_add.php";

// Get info
if($nRecID){
	$nSQL = "SELECT * FROM nPage WHERE nID='$nRecID' LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"];
		$nNavTitle = $Row["nNavTitle"];
		$nTitle = $Row["nTitle"];
		$nBGColor = $Row["nBGColor"];
		$nBaseColor = $Row["nBaseColor"];
		$nBGImgID = $Row["nBGImgID"];
		$nType = $Row["nType"];
		$nSectionID = $Row["nSectionID"];
		$nOrderID = $Row["nOrderID"];
	} else { echo "<div align=\"center\" style=\"padding:20px;\"><em>No record found.</em></div>"; }
}

if($nLocked){ exit("This record is locked and cannot be edited."); }

$nHomepageCount = nGetHomepageCount();
$nSearchPageCount = nGetSearchPageCount();
?>

<div id="<?=$nDivToUpdate;?>">
<?php
include("../inc/form_class.php");

$nFormName = "FormPageAdd";
$nForm1 = new Form();
//$nForm1->DEBUG = true;
$nForm1->Name = $nFormName;
$nForm1->Action = $_SERVER['PHP_SELF'];
$nForm1->CancelText = "Cancel";
$nForm1->CancelRedirect = "Modalbox.hide();return false;";
$nForm1->CancelRedirectIsJS = true;
if($nRecID){
	$nForm1->SubmitText = "Update";
} else {
	$nForm1->SubmitText = "Add New Page";
}
$nForm1->DBLink = $Link;
$nForm1->nUseADODB = false;
// AJAX settings
$nForm1->SubmitIsJS = true;
$nForm1->SubmitToJS = "return submitForm('$nDivToUpdate','$nPageInDiv$nPassThru','$nFormName');return false;";
$nForm1->DontProcess = "id,nDocumentList";

// Create groups
$nFormGroup1 = new FormGroup();
$nFormGroup1b = new FormGroup();
$nFormGroup2 = new FormGroup();
$nFormGroup2->Class = "contentGrp";
$nFormGroup3 = new FormGroup();
$nFormGroup3->Class = "linkGrp";
if($nType!="Link"){ $nFormGroup3->Style = "display:none;"; }

// Create fields
if($nRecID){
	$nFormField = new FormField("hidden","id");
	$nFormField->Value = $nRecID;
	$nFormGroup1->AddField($nFormField);
}
$nForm1->AddGroup($nFormGroup1);

foreach($nActiveLangARRAY as $nLangCode => $nLangName) {
	$nFormGroup1 = new FormGroup();
	
	if($nLangCode==$nDefaultLang){ $nLangSuffix = ""; } else { $nLangSuffix = "_$nLangCode"; $nFormGroup1->Style = "display:none;"; }
	$nFormGroup1->ID = "tabbody_$nLangCode";
	
	if(count($nActiveLangARRAY)>1){ $nLangText = " ($nLangName)"; } else { $nLangText = ""; }
	$nFormField = new FormField("text","nNavTitle$nLangSuffix","Page Title$nLangText:");
	$nFormField->Caption = "(for navigation, max. 100 characters)";
	$nFormField->Value = nGetLangContent($nLangCode,$nRecID,"page","nText");
	if($nLangCode==$nDefaultLang){ $nFormField = $nForm1->AddValidation("required",$nFormField); }
	$nFormField = $nForm1->AddValidation("maxlength",$nFormField,100);
	$nFormGroup1->AddField($nFormField);
	
	$nForm1->AddGroup($nFormGroup1);
}
if(count($nActiveLangARRAY)>1){ $nForm1->AddGroup(nGetLangTabGroup()); }

$nFormField = new FormField("select","nType","Page Type:");
$nDataARRAY = array();
$nDataARRAY["Content"] = "Content";
$nDataARRAY["Link"] = "Link";
if($nHomepageCount===0 || $nType=="Homepage"){ $nDataARRAY["Homepage"] = "Homepage"; }
if($nSearchPageCount===0 || $nType=="Search"){ $nDataARRAY["Search"] = "Search"; }
$nFormField->DataARRAY = $nDataARRAY;
if($nRecID){
	$nFormField->SelectedARRAY = array("$nType" => "selected");
} else {
	$nFormField->SelectedARRAY = array("Content" => "selected"); // default
}
$nFormField->RowSize = "Half";
$nFormField->onBlur = "togglePageFields(this.value);";
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormGroup1b->AddField($nFormField);

$nFormField = new FormField("select","nSectionID","Section:");
$nFormField->DataARRAY = nGetSectionARRAY();
if($nRecID){ $nFormField->SelectedARRAY = array("$nSectionID" => "selected"); }
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormField->RowSize = "Half";
$nFormField->Style = "width:200px;";
$nFormGroup1b->AddField($nFormField);

/*
$nFormField = new FormField("select","nBGImgID","Background Image:");
$nFormField->Caption = "Select and <a href=\"javascript:;\" onClick=\"previewImg();\">preview</a> image, or <a href=\"popup_imglib.php?t=Background\" target=\"imgLib\" onClick=\"PopUp(this.href,this.target,720,480,1);\">manage images in the image library</a>.";
$nFormField->DataARRAY = nGetImgARRAY("Background");
if($nBGImgID){
	$nFormField->SelectedARRAY = array("$nBGImgID" => "selected");
} else {
	$nFormField->SelectedARRAY = array("0" => "selected"); // default
}
$nFormField->RowSize = "Half";
$nFormField->Style = "width:200px;";
$nFormField->RowStyle = "clear:both;float:none;";
$nFormGroup2->AddField($nFormField);
*/

$nFormField = new FormField("radio","nBGColor","Icon Color:");
$nFormField->DataARRAY = array(
	"#007bb6" => "<strong style='background-color:#007bb6;padding:2px;color:#FFF;width:20px;'>&nbsp; &nbsp;</strong>",
	"#bac870" => "<strong style='background-color:#bac870;padding:2px;color:#FFF;width:20px;'>&nbsp; &nbsp;</strong>",
	"#dd1a21" => "<strong style='background-color:#dd1a21;padding:2px;color:#FFF;width:20px;'>&nbsp; &nbsp;</strong>",
	"#bb1b8d" => "<strong style='background-color:#bb1b8d;padding:2px;color:#FFF;width:20px;'>&nbsp; &nbsp;</strong>",
	"#f99f1c" => "<strong style='background-color:#f99f1c;padding:2px;color:#FFF;width:20px;'>&nbsp; &nbsp;</strong>",
	"#009f4f" => "<strong style='background-color:#009f4f;padding:2px;color:#FFF;width:20px;'>&nbsp; &nbsp;</strong>",
	"#d76e2a" => "<strong style='background-color:#d76e2a;padding:2px;color:#FFF;width:20px;'>&nbsp; &nbsp;</strong>",
	"#ff6a14" => "<strong style='background-color:#ff6a14;padding:2px;color:#FFF;width:20px;'>&nbsp; &nbsp;</strong>",
	"#00b1b7" => "<strong style='background-color:#00b1b7;padding:2px;color:#FFF;width:20px;'>&nbsp; &nbsp;</strong>",
	"#bbd821" => "<strong style='background-color:#bbd821;padding:2px;color:#FFF;width:20px;'>&nbsp; &nbsp;</strong>",
	"#000000" => "<strong style='background-color:#000000;padding:2px;color:#FFF;width:20px;'>&nbsp; &nbsp;</strong>");
if($nBGColor){
	$nFormField->SelectedARRAY = array("$nBGColor" => "selected");
} else {
	$nFormField->SelectedARRAY = array("#007bb6" => "selected"); // default
}
//$nFormField->Caption = "Choose the page background color.";
$nFormGroup2->AddField($nFormField);

$nFormField = new FormField("select","nDocumentList","Choose a document to link to:");
$nFormField->DataARRAY = nGetDocumentARRAY();
if($nRecID){ $nFormField->SelectedARRAY = array("$nTitle" => "selected"); }
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormField->RowSize = "Half";
$nFormField->Style = "width:400px;";
$nFormField->onBlur = "autoFillTitle(this);";
$nFormGroup3->AddField($nFormField);

$nFormField = new FormField("text","nTitle","...or write in your own link:");
$nFormField->Caption = "(ex. http://www.google.com/ ...or... /img/pdf/my_doc.pdf)";
$nFormField->Value = $nTitle;
$nFormField->Style = "width:400px;";
$nFormGroup3->AddField($nFormField);

// Finalize and display form
$nForm1->AddGroup($nFormGroup1b);
$nForm1->AddGroup($nFormGroup2);
$nForm1->AddGroup($nFormGroup3);
$nFormToDisplay = $nForm1->GetForm();

// AJAX redirect if form submitted w/o error, otherwise display form (again, if necessary)
if($nForm1->HasProcessed){
	// Post-processing
	$nRecID = $_POST["id"];
	$nNavTitle = nConvertIntChars($_POST["nNavTitle"]);
	$nType = $_POST["nType"];
	$nSectionID = $_POST["nSectionID"];
	$nBGColor = $_POST["nBGColor"];
	$nTitle = $_POST["nTitle"];
	if($nRecID){
		// editing existing page
		$Query = "UPDATE nPage SET nNavTitle='$nNavTitle',nType='$nType',nSectionID='$nSectionID',nBGColor='$nBGColor',nTitle='$nTitle' WHERE nID=$nRecID LIMIT 1";
		mysql_select_db($DBName);
		mysql_query($Query, $Link);
	} else {
		// creating new page
		$Query = "INSERT INTO nPage (nNavTitle,nType,nSectionID,nBGColor,nTitle) VALUES ('$nNavTitle','$nType','$nSectionID','$nBGColor','$nTitle')";
		mysql_select_db($DBName);
		mysql_query($Query, $Link);
		$nRecID = mysql_insert_id(); // gets ID of last created row
	}
	// Update all additional language fields (default language already saved)
	if($nRecID && count($nActiveLangARRAY)){
		foreach($nActiveLangARRAY as $nLangCode => $nLangName) {
			$nType = "page";
			// if default language is not used, get translation from additional fields
			if($nLangCode!=$nDefaultLang){
				// Name
				$nFieldName="nNavTitle_".$nLangCode;
				$nNavTitle = trim($_POST[$nFieldName]);
				$nNavTitle = nConvertIntChars($nNavTitle);
			} else {
				$nName = nConvertIntChars($_POST["nNavTitle"]);
			}
			if($nRecID){
				// first remove any current content for this language
				$Query = "DELETE FROM nTranslate WHERE nLang='$nLangCode' AND nItemID='$nRecID' AND nType='$nType'";
				mysql_select_db($DBName);
				mysql_query($Query, $Link);
				//print "$Query<BR><BR>";
			}
			// now save new content
			if($nRecID){
				$Query = "INSERT INTO nTranslate VALUES ('','$nLangCode','$nRecID','$nType','$nNavTitle','','','','1')";
				mysql_select_db($DBName);
				mysql_query($Query, $Link);
				//print "$Query<BR><BR>";
			}
		}
	}
	// Finalize color scheme
	switch($_POST["nBGColor"]){
		case "#007bb6": $nBaseColor="#bac870"; $nBackBGColor="#dcf2f6"; break;
		case "#bac870": $nBaseColor="#007bb6"; $nBackBGColor="#ebefd6"; break;
		case "#dd1a21": $nBaseColor="#007bb6"; $nBackBGColor="#ffe683"; break;
		case "#bb1b8d": $nBaseColor="#007bb6"; $nBackBGColor="#ebe0ef"; break;
		case "#f99f1c": $nBaseColor="#007bb6"; $nBackBGColor="#fff8a7"; break;
		case "#009f4f": $nBaseColor="#007bb6"; $nBackBGColor="#d5ebdb"; break;
		case "#d76e2a": $nBaseColor="#007bb6"; $nBackBGColor="#f8e8d0"; break;
	}
	if($_POST["id"]){
		// Update color scheme
		$Query = "UPDATE nPage SET nBaseColor='$nBaseColor',nBackBGColor='$nBackBGColor' WHERE nID=$nRecID LIMIT 1";
		mysql_select_db($DBName);
		mysql_query($Query, $Link);
		echo "<script>$nRefreshCall Modalbox.hide();</script>";
	} else {
		if($nRecID){
			// Update color scheme
			$Query = "UPDATE nPage SET nBaseColor='$nBaseColor',nBackBGColor='$nBackBGColor' WHERE nID=$nRecID LIMIT 1";
			mysql_select_db($DBName);
			mysql_query($Query, $Link);
			// Create default components for this page type
			if($_POST["nType"]=="Content"){
				// Title
				//$Query = "INSERT INTO xComponentPage (nComponentID,nPageID,nColumnID) VALUES (1,$nRecID,1)";
				//mysql_select_db($DBName);
				//mysql_query($Query, $Link);
			}
		}
		
		if($_POST["nType"]=="Content"){
			echo "<div align=\"center\" id=\"buttonBox\"><BR>";
				echo "<strong>New page '".$_POST["nNavTitle"]."' has been succesfully created!</strong><BR><BR>";
				echo "What do you want to do next?<BR><BR>";
				echo "<input type=\"button\" name=\"nEdit\" value=\"Edit this Page\" onClick=\"document.location.href='page_edit.php?id=".$nRecID."'\" class=\"formSubmit\"> ";
				echo "<input type=\"button\" name=\"nClose\" value=\"Close\" onClick=\"Modalbox.hide();\" class=\"formCancel\"> ";
			echo "</div>";
			echo "<script>$nRefreshCall Modalbox.resizeToContent();</script>";
		} else {
			echo "<script>$nRefreshCall Modalbox.hide();</script>";
		}
	}
} else {
	echo $nFormToDisplay;
	echo "<script>Modalbox.resizeToContent();</script>";
}
?>
</div>
<script>
autoFillTitle = function(fld){
	if(fld.value && fld.value!=0){ $('nTitle').value=fld.value; }
}
refreshParentsPageAdd = function(){
	try{ refreshPageComps(); } catch(e){ }
	try{ refreshPages(); } catch(e){ }
}
togglePageFields = function(fldValue){
	if(fldValue=="Link"){
		//$$('div.contentGrp').each( function(c) { c.hide(); });
		$$('div.linkGrp').each( function(c) { c.show(); });
		Modalbox.resizeToContent();
	} else {
		$$('div.linkGrp').each( function(c) { c.hide(); });
		//$$('div.contentGrp').each( function(c) { c.show(); });
		Modalbox.resizeToContent();
	}
}
</script>
<?php
function nGetNextPageNum(){
	global $DBName,$Link;
	$nSQL = "SELECT Max(nID) AS nID FROM nPage";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"] + 1;
	}
	return $nID;
}
function nGetDocumentARRAY(){
	global $DBName,$Link;
	$nDataARRAY = array();
	$nDataARRAY[] = "- Please choose -";
	$nSQL = "SELECT nPath FROM nFile ORDER BY nPath ASC";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	while($Row = mysql_fetch_array($Result)){
		$nPath = $Row["nPath"];
		$nPath = str_replace("usr/docs/","/usr/docs/",$nPath);
		$nPathTxt = str_replace("usr/docs/","",$nPath);
		$nDataARRAY["$nPath"] = "$nPathTxt";
	}
	return $nDataARRAY;
}
function nGetSectionARRAY(){
	global $DBName,$Link;
	global $nRecID;
	$nDataARRAY = array();
	$nSQL = "SELECT * FROM nSection ORDER BY nParentID,nName ASC";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	while($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"];
		$nName = $Row["nName"];
		$nParentID = $Row["nParentID"];
		if($nParentID){ $nDataARRAY["$nID"] = "- $nName"; } else { $nDataARRAY["$nID"] = "$nName"; }
	}
	return $nDataARRAY;
}
function nGetHomepageCount(){
	global $DBName,$Link;
	$nSQL = "SELECT nID FROM nPage WHERE nType='Homepage'";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	$nCount = mysql_num_rows($Result);
	return $nCount;
}
function nGetSearchPageCount(){
	global $DBName,$Link;
	$nSQL = "SELECT nID FROM nPage WHERE nType='Search'";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	$nCount = mysql_num_rows($Result);
	return $nCount;
}
function nGetImgARRAY($nFilter=""){
	global $DBName,$Link;
	$nDataARRAY = array();
	$nDataARRAY[0] = "- No image -";
	if($nFilter){ $nWhereSQL = "WHERE nType='$nFilter'"; }
	$nSQL = "SELECT nID,nPath FROM nImage $nWhereSQL";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	while($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"];
		$nPath = $Row["nPath"];
		$nDataARRAY["$nID"] = "$nPath";
	}
	return $nDataARRAY;
}
// returns array of active storefront languages in alpha order, default will be first item in array 
function nGetLangActiveARRAY(){
	global $nDefaultLang;
	$nDefaultLangARRAY = array();
	$nLangARRAY = array();
	// Get all files in directory
	$path = "../../lang/";    
	$dir_handle = @opendir($path) or die("Unable to open $path");    
	while ($file = readdir($dir_handle)) {
		if($file == "." || $file == ".." || $file == "index.php" )
			continue;
		$nFileCode = str_replace(".php","",$file);
		if(!is_dir("$path$file/")){
			if(file_exists("$path$file")){ require("$path$file"); }
			if($nFileCode == $nDefaultLang){
				if($nLang){ $nDefaultLangARRAY["$nFileCode"] = $nLang; } // default language
			} else {
				if($nLang){ $nLangARRAY["$nFileCode"] = $nLang; }
			}
		}
	}
	closedir($dir_handle);
	krsort($nLangARRAY);
	foreach($nDefaultLangARRAY as $nLangCode => $nLangName) {
		$nLangARRAY["$nLangCode"] = $nLangName;
	}
	$nLangARRAY = array_reverse($nLangARRAY,true);
	return $nLangARRAY;
}
function nGetLangTabGroup(){
	global $nActiveLangARRAY,$nDefaultLang;
	$nFormGroup1 = new FormGroup();
	$nHideCodeJS = "";
	foreach($nActiveLangARRAY as $nLangCode => $nLangName) { $nHideCodeJS.="$('tabbody_$nLangCode').hide(); $('tab_$nLangCode').className='langTab';"; }
	foreach($nActiveLangARRAY as $nLangCode => $nLangName) {
		if($nLangCode==$nDefaultLang){ $nLangSuffix = ""; $nClass="langTabActive"; } else { $nLangSuffix = "_$nLangCode"; $nClass="langTab"; }
		$nLangLinks.="<a href=\"javascript:;\" onClick=\"$nHideCodeJS $('tabbody_$nLangCode').show(); $('tab_$nLangCode').className='langTabActive';\" id=\"tab_$nLangCode\" class=\"$nClass\">$nLangName</a> ";
	}
	$nFormField = new FormField("static","","Language: $nLangLinks");
	$nFormField->RowStyle = "clear:both;float:none;font-weight:bold;";
	$nFormGroup1->AddField($nFormField);
	return $nFormGroup1;
}
function nGetLangContent($nLangCode,$nItemID,$nType,$nFieldName,$nOrderID=1){
	global $DBName, $Link;
	if(!$nLangCode || !$nItemID || !$nType || !$nFieldName){ return; };
	$Query = "SELECT $nFieldName AS nContent FROM nTranslate WHERE nLang='$nLangCode' AND nItemID='$nItemID' AND nType='$nType' AND nOrderID='$nOrderID'";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nContent = $Row["nContent"];
	}
	return $nContent;
}
function nConvertIntChars($nText){
	if(!$nText){ return; }
	// lowercase
	$nText = str_replace("","&uacute;",$nText);
	$nText = str_replace("","&iacute;",$nText);
	$nText = str_replace("","&oacute;",$nText);
	$nText = str_replace("","&eacute;",$nText);
	$nText = str_replace("","&aacute;",$nText);
	$nText = str_replace("","&ntilde;",$nText);
	// uppercase
	$nText = str_replace("","&Uacute;",$nText);
	$nText = str_replace("","&Iacute;",$nText);
	$nText = str_replace("","&Oacute;",$nText);
	$nText = str_replace("","&Eacute;",$nText);
	$nText = str_replace("","&Aacute;",$nText);
	$nText = str_replace("","&Ntilde;",$nText);
	return $nText;
}
?>
<? require("../../inc/db_close.php"); ?>
