<?php
/*
 * This file is part of Web Pro Manager.
 * 
 * Web Pro Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Web Pro Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Web Pro Manager.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author The Web Pro Miami, Inc. <info@thewebpro.com>
 * @copyright The Web Pro Miami, Inc. <info@thewebpro.com>, http://www.thewebpro.com/
 * @license http://www.gnu.org/licenses/gpl.html GNU GPL
 * @package WebProManager
*/

/*
 * This file is part of Web Pro Manager.
 * 
 * Web Pro Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Web Pro Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Web Pro Manager.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author The Web Pro Miami, Inc. <info@thewebpro.com>
 * @copyright The Web Pro Miami, Inc. <info@thewebpro.com>, http://www.thewebpro.com/
 * @license http://www.gnu.org/licenses/gpl.html GNU GPL
 * @package WebProManager
*/

require("../inc/stop_cache.php");
$nAdminOnlyPg = 1;
require("../inc/secure_page.php");
// connect to mysql
require("../../inc/dbconnect.php");
include("../inc/paginator.php");
include("../inc/pageutil.php");
include("../inc/calendar.php");
require("../inc/langutil.php");

$nShowPerPg = 20;

$nCompPath = "../../comp/";

// Get all new components and import them into the database
nImportNewComps();

// Clean out components that exist in database but not found in "comp" folder
////nCleanDiscardedComps();

// Get passed-in vars
$nPage = $_GET["pg"]; if(!$nPage){ $nPage = $_POST["pg"]; }
$nSort = $_GET["srt"];
$nSortOrder = $_GET["ord"];
$nShowPerPgOverride = $_GET["spp"];
if($nShowPerPgOverride){ $nShowPerPg = $nShowPerPgOverride; }

// Setup SQL query for displayed listing
if(!$nSort){ $nSort="nName"; }  // default sort
if(!$nSortOrder){ $nSortOrder="ASC"; }  // default sort order
if($nUserID){ $nWhereARRAY[] = "nID='$nUserID'"; }

if($nWhereARRAY){ $nWhereSQL = "WHERE ".implode(" AND ",$nWhereARRAY); }
$nOrderBySQL = "ORDER BY $nSort $nSortOrder";
$nListingSQL = "SELECT * From nComponent $nWhereSQL $nOrderBySQL";
?>
<div id="listContent" style="padding-top:0px;">
<?php
$nPassThruReq = "";
$nDivToUpdate = "ajaxComponents";
$nPageInDiv = "list/components.php";
$nCurrQueryStr = $_SERVER['QUERY_STRING'];
if($nCurrQueryStr){ $nFullPageInDiv = $nPageInDiv."?".$nCurrQueryStr; } else { $nFullPageInDiv = $nPageInDiv; }
$nPagingText = nGetPaging($nListingSQL,$nPage,$nShowPerPg,$nPassThru,$nDivToUpdate,$nPageInDiv);
if($nPassThru){ $nPassThruQry="?".$nPassThru; $nPassThru="&".$nPassThru; }
// for extrenal refresh requests
print "<script>refreshComps = function(){ loadContent('".$nDivToUpdate."','".$nFullPageInDiv."'); }</script>";
?>

<!--[if !IE]>start section inner<![endif]-->
<div class="section_inner">
	<!--[if !IE]>start table_wrapper<![endif]-->
	<div class="table_wrapper">
		<div class="table_wrapper_inner">
		<table cellpadding="0" cellspacing="0" width="100%">
			<tbody><tr>
				<th style="width:25px;">No.</th>
				<?$nSortFld="nName"; if($nSortFld==$nSort){ if($nSortOrder=="ASC"){ $nLink="?srt=$nSortFld&ord=DESC$nPassThru";$nSortClass=" class=\"asc\""; } else { $nLink="?srt=$nSortFld&ord=ASC$nPassThru";$nSortClass=" class=\"desc\""; } } else { $nLink="?srt=$nSortFld&ord=ASC$nPassThru";$nSortClass=""; }?>
				<th><a href="javascript:loadContent('<?=$nDivToUpdate?>','<?=$nPageInDiv.$nLink?>');"<?=$nSortClass;?>>Component Name</a></th>
				<?$nSortFld="nActive"; if($nSortFld==$nSort){ if($nSortOrder=="ASC"){ $nLink="?srt=$nSortFld&ord=DESC$nPassThru";$nSortClass=" class=\"asc\""; } else { $nLink="?srt=$nSortFld&ord=ASC$nPassThru";$nSortClass=" class=\"desc\""; } } else { $nLink="?srt=$nSortFld&ord=ASC$nPassThru";$nSortClass=""; }?>
				<th width="80" style="text-align:center;"><a href="javascript:loadContent('<?=$nDivToUpdate?>','<?=$nPageInDiv.$nLink?>');"<?=$nSortClass;?>>Active?</a></th>
				<th width="80" style="text-align:center;">Usage</th>
				<th style="width:96px;">Actions</th>
			</tr>
			<?=nGetCompList();?>
		</tbody></table>
		</div>
	</div>
	<!--[if !IE]>end table_wrapper<![endif]-->
</div>
<!--[if !IE]>end section inner<![endif]-->

<? if($nTotalPg>1){ ?>
	<!--[if !IE]>start pagination<![endif]-->
	<div class="pagination">
		<?=$nPagingText;?>
	</div>
	<!--[if !IE]>end pagination<![endif]-->
<? } else {?>
	<!--[if !IE]>start pagination<![endif]-->
	<div class="pagination">
		<span class="page_no">Page 1 of 1</span>
	</div>
	<!--[if !IE]>end pagination<![endif]-->
<? } ?>


<?php
function nGetCompList(){
	global $DBName,$Link,$nListingSQL;
	global $nShowPerPg,$nTotalRec,$nStartRec,$nEndRec,$nTotalPg;
	if(!$nListingSQL){ return ""; }
	$nCurrRec = 0;
	$Result = mysql_db_query ($DBName,$nListingSQL,$Link);
	while($Row = mysql_fetch_array($Result)){
		$nCurrRec++;
		if($nCurrRec>=$nStartRec && $nCurrRec<=$nEndRec && $nCurrRec<=$nTotalRec){
			$nID = $Row["nID"];
			$nName = $Row["nName"];
			$nActive = $Row["nActive"];
			if($nActive){
				$nActive="Active";
				//$nEditCODE = "<li><a class=\"edit\" href=\"dialog/component_files_edit.php?id=$nID\" title=\"Edit Component\" onClick=\"Modalbox.show(this.href,{title: this.title, width: 500, overlayClose:false}); return false;\">Edit</a></li>";
				$nEnableCODE = "<li><a class=\"delete\" href=\"dialog/component_toggle.php?id=$nID\" title=\"Toggle Component\" onClick=\"Modalbox.show(this.href,{title: this.title, width: 450, overlayClose:false}); return false;\">Disable</a></li>";
			} else {
				$nActive="<span style=\"color:#AA0000;\">Disabled</span>";
				//$nEditCODE = "<li><a class=\"edit\" href=\"dialog/component_files_edit.php?id=$nID\" title=\"Edit Component\" onClick=\"Modalbox.show(this.href,{title: this.title, width: 500, overlayClose:false}); return false;\">Edit</a></li>";
				$nEnableCODE = "<li><a class=\"approve\" href=\"dialog/component_toggle.php?id=$nID\" title=\"Toggle Component\" onClick=\"Modalbox.show(this.href,{title: this.title, width: 450, overlayClose:false}); return false;\">Enable</a></li>";
			}
			$nPageUsage = nGetPageCount($nID);
			if(!$nName){ $nName="<span class=\"caption\"><em>&lt;unnamed&gt;</em></span>"; }
			if($nRowClass=="second"){ $nRowClass="first"; } else { $nRowClass="second"; }
			$nTable.= <<<CODE
			<tr id="row$nCurrRec" class="$nRowClass" onMouseOver="$('row$nCurrRec').addClassName('rowhilite');" onMouseOut="$('row$nCurrRec').removeClassName('rowhilite');">
				<td>$nCurrRec.</td>
				<td><strong>$nName</strong></td>
				<td align="center" style="text-align: center;">$nActive</td>
				<td align="center" style="text-align:center;">$nPageUsage pages</td>
				<td>
					<div class="actions_menu" style="margin:6px 0;">
						<ul>
							$nEditCODE
							$nEnableCODE
						</ul>
					</div>
				</td>
			</tr>
CODE;
		}
	}
	if(!$nTable){ $nTable = "<tr id=\"$nRowClass\"><td height=\"200\" align=\"center\" class=\"caption\" colspan=\"5\"><em>No data available to display.</em></td></tr>"; }
	return $nTable;
}

function nGetPageCount($nCompID){
	global $DBName,$Link;
	if($nSectionID===""){ return 0; }
	$nNumRecords = 0;
	$nSQL = "SELECT nPageID FROM xComponentPage WHERE nComponentID=$nCompID GROUP BY nPageID";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	$nNumRecords = mysql_num_rows($Result);
	return $nNumRecords;
}

// to capture calls and prevent errors from included comp, but not needed to run now
function addField($nFldID="",$nTitle="",$nCaption="",$nDefVal=""){
	return;
}

function nImportNewComps(){
	global $DBName,$Link;
	global $nCompPath,$nDefaultLang;
	// Get all files in Components directory
	$dir_handle = @opendir($nCompPath) or die("Unable to open Component path: $nCompPath");
	while ($file = readdir($dir_handle)) {
		if($file == "." || $file == ".." || $file == "index.php" )
			continue;
		if(!is_dir("$nCompPath$file")){
			// reset imported vars
			$nName = ""; $nDescription = ""; $nPageTypeLimit = ""; $nTemplateFile = "";
			$nFileName="$file";
			$nFilePath="$nCompPath$file";
			if(file_exists("$nFilePath")){
				// Pull in component settings file
				// include($nFilePath);
				$nConnFile = fopen($nFilePath,"r");
				if($nConnFile){
					$nFileCode = fread($nConnFile,filesize($nFilePath));
					fclose($nConnFile);
				} else { return 0; }
				$nFileCodeARRAY = explode("\r\n",$nFileCode);
				if(strpos($nFileCodeARRAY[2],"nName")){ eval($nFileCodeARRAY[2]); }
				if(strpos($nFileCodeARRAY[3],"nDescription")){ eval($nFileCodeARRAY[3]); }
				if(strpos($nFileCodeARRAY[4],"nPageTypeLimit")){ eval($nFileCodeARRAY[4]); }
				if(strpos($nFileCodeARRAY[5],"nTemplateFile")){ eval($nFileCodeARRAY[5]); }
				if($nName){
					$nCompID = nGetCompIDFromName($nName);
					//print "id exists for $nName: $nCompID<BR>";
					if($nTemplateFile && !$nCompID){ // if comp doesn't already exist in DB (no ID exists), add it
						$nName = nTruncateString(trim($nName),50);
						$nDescription = addslashes(nTruncateString(trim($nDescription),255));
						$nPageTypeLimit = addslashes(nTruncateString(trim($nPageTypeLimit),50));
						$nTemplateFile = nTruncateString(trim($nTemplateFile),255);
						$nTemplateFilePath="$nCompPath$nTemplateFile";
						$nLangPath = "$nDefaultLang/";
						$nTemplateOverridePath = "$nCompPath$nLangPath$nTemplateFile";
						//print "template file ($nTemplateFilePath) exists? ".file_exists("$nTemplateFilePath")."<BR>";
						//print "template override file ($nTemplateOverridePath) exists? ".file_exists("$nTemplateOverridePath")."<BR>";
						// Add plugin to database un-activated if all tests passed
						if($nName && (file_exists("$nTemplateFilePath") || file_exists("$nTemplateOverridePath"))){
							//print "saving to db<BR>";
							$Query = "INSERT INTO nComponent VALUES ('0','$nName','$nDescription','1','$nPageTypeLimit','$nFileName')";
							mysql_select_db($DBName);
							mysql_query($Query, $Link);
						}
					}
				}
			}
		}
	}
	closedir($dir_handle);
	return $nTable;
}
function nTruncateString($nStr,$nMax){
  if(strlen($nStr)>$nMax) {
    $leave = $max - strlen($rep);
    return substr($nStr,0,$nMax);
  }
  return $nStr;
}
function nGetCompIDFromName($nCompName){
	global $DBName, $Link;
	if(!$nCompName){ return; }
	$Query = "SELECT nID FROM nComponent WHERE nName='$nCompName'";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nID = $Row[nID];
	}
	return $nID;
}
function nCleanDiscardedComps(){
	global $DBName,$Link;
	global $nCompPath;
	$dir_handle = @opendir($nCompPath) or die("Unable to open Component path: $nCompPath");
	$Query = "SELECT nPluginID FROM nPlugins";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	$nCurrentRecord = 0;
	while ($Row = mysql_fetch_array($Result)) {
		$nPluginID = $Row[nPluginID];
		$nMasterFilePath = "$nCompPath$nPluginID/$nPluginID.php";
		if(!is_dir("$nCompPath$nPluginID/") || !file_exists("$nMasterFilePath")){
			nDeletePlugin($nPluginID);
		}
	}
	closedir($dir_handle);
	return;
}
function nDeletePlugin($nPluginID){
	global $DBName,$Link;
	global $nCompPath;
	if(!$nPluginID){ return; }
	$nMasterPluginPath = "$nCompPath$nPluginID/";
	// Remove folder
	if(is_dir("$nMasterPluginPath")){ nRecursiveDelete("$nMasterPluginPath"); }
	// Remove record
	$Query = "DELETE FROM nPlugins WHERE nPluginID='$nPluginID' LIMIT 1";
	mysql_select_db($DBName);
	mysql_query($Query, $Link);
	// Remove all associated databases
	mysql_select_db($DBName);
	$Query = "SHOW TABLES FROM $DBName";
	$result = mysql_query($Query);
	while ($Row = mysql_fetch_row($result)) {
	    $nTableName = $Row[0];
		$pos = strpos($nTableName, $nPluginID);
		if($pos !== false){
			// Remove record
			$Query = "DROP TABLE IF EXISTS $nTableName";
			mysql_select_db($DBName);
			mysql_query($Query, $Link);
		}
	}
	// REMOVE all associated navigation items
	$Query = "DELETE FROM nPluginNav WHERE nPluginID='$nPluginID'";
	mysql_select_db($DBName);
	mysql_query($Query, $Link);
	// REMOVE all associated inclusion points
	$Query = "DELETE FROM nPluginInclusionPoint WHERE nPluginID='$nPluginID'";
	mysql_select_db($DBName);
	mysql_query($Query, $Link);
}
function nRecursiveDelete($str){
	if(is_file($str)){
		return @unlink($str);
	} elseif(is_dir($str)){
		$scan = glob(rtrim($str,'/').'/*');
		foreach($scan as $index=>$path){
			nRecursiveDelete($path);
		}
		return @rmdir($str);
	}
}
?>
<? require("../../inc/db_close.php"); ?>
